unit Main_KochOPC;
{  Colin read this :
We Use QuickOPC from QuickOPC.com, the method we use is the COM interface and these are the instructions to import
the library. WARNING: if you update the client then the Dev PC must be running the same version
of the QuickOPC to ensure that all the COM interface calls are valid. So If we update the Client
we must remove QuickOPC on the Dev machine, then Reinstall it. Then Recreate the TLB files
using the following Method.

In Delphi, importing a Type Library (TLB) allows you to utilize COM (Component Object Model)
objects and interfaces provided by that library. Delphi generates a corresponding PAS file
that exposes the interfaces and objects.

Here's a step-by-step guide on how to import a Type Library in Delphi:
WARNING: make sure you set the Create wrapper = ON !!
https://opclabs.doc-that.com/files/onlinedocs/QuickOpc/Latest/User's%20Guide%20and%20Reference-QuickOPC/Importing%20Type%20Libraries%20to%20Delphi.html#:~:text=1%20In%20Delphi%2C%20select%20command%20Component%20-%3E%20Import,library%2C%20repeat%20the%20process%20from%20Step%201.%20

Remember, interfaces to COM objects behave a bit differently than typical
Delphi objects. Be sure to familiarize yourself with reference counting,
where Delphi has to make sure objects are released of the memory is leaked
and never returned and if you're dealing with controls, how they are
embedded and hosted within Delphi forms.

As versions change, there might be slight variations in steps or
enhanced features added. Always refer to the Delphi documentation
or help files for any version-specific information.
Colin ....13 Sep 2023

Currently the Libray files are created in the following folder
   C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_EasyOpcForms_TLB.dcr"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_EasyOpcForms_TLB.pas"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_EasyOpcUA_TLB.dcr"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_EasyOpcUA_TLB.pas"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs.BaseLib.tlb"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs.BaseLibForms.tlb"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs.EasyOpcClassic.tlb"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs.EasyOpcForms.tlb"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs.EasyOpcUA.tlb"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_BaseLib_TLB.dcr"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_BaseLib_TLB.pas"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_BaseLibForms_TLB.dcr"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_BaseLibForms_TLB.pas"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_EasyOpcClassic_TLB.dcr"
      "C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports\OpcLabs_EasyOpcClassic_TLB.pas"

 Delphi Uses the TLB files at the location
 C:\Users\Antigua\Documents\Embarcadero\Studio\22.0\Imports
 for its compiler


 Delphi online OPC guide @
 https://opclabs.doc-that.com/files/onlinedocs/QuickOpc/2021.2/User's%20Guide%20and%20Reference-QuickOPC/webframe.html#Object%20Pascal%20Examples%20(Delphi).html

 Found out
 Afetr Version 2021.2 the modules have been renamed. From  2021.2 was the last version in
 which this object was called EasyUAClientConfiguration; in newer versions it is EasyUAClientManagement.

 }



interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls
  , OpcLabs_EasyOpcUA_TLB
  , OpcLabs_EasyOpcForms_TLB
  , OpcLabs_BaseLib_TLB,
  System.Threading, Vcl.ExtCtrls, DateUtils, ppCtrls, ppPrnabl, ppClass,
  ppCache, ppBands, ppDesignLayer, ppParameter, ppDB, ppDBJIT, ppComm, ppRelatv,
  ppProd, ppReport, AdvPanel, AdvGlowButton, Vcl.Buttons, DBAccess, Uni,
  Data.DB, MemDS,system.Math, AdvLabel, AdvMultiInputQueryDialog,
  AdvSmoothSlider, DBAdvSmoothSlider, Vcl.Mask, AdvDropDown,
  AdvCustomGridDropDown, AdvGridDropDown, AdvToolBar, AdvFontCombo,
  AdvScrollControl, AdvRichEditorBase, AdvRichEditor,
  IOUtils, VrControls, VrLabel;


type

// ZKPTYPE, Pallet Type 100 = Euro 200 = CHEP
// ZKEASYL, Easyloader layout code
// ZKPRPL   Rolls Per layer

  // Information that gets Sent to Koch from Siva
  TRunningJobs  = Record
   EmployeeNoL1       : Integer;
   WorksorderNoL1     : Integer;
   MachineNoL1        : Integer;

   EmployeeNoL2       : Integer;
   WorksorderNoL2     : Integer;
   MachineNoL2        : Integer;

   EmployeeNoL3       : Integer;
   WorksorderNoL3     : Integer;
   MachineNoL3        : Integer;

   EmployeeNoL4       : Integer;
   WorksorderNoL4     : Integer;
   MachineNoL4        : Integer;

   EmployeeNoL5       : Integer;
   WorksorderNoL5     : Integer;
   MachineNoL5        : Integer;

   EmployeeNoL6       : Integer;
   WorksorderNoL6     : Integer;
   MachineNoL6        : Integer;
  End;


  TOrderInfo =  record
   RollsPerLayer          : Integer;
   Layersperpallet        : Integer;
   //TypeOfpallet           : Integer; // SLITTING 100=CHEP , 200 = EURO Pallet for
   PackingPattern         : Integer; // This is the individual Roll Packing 0= None 1..4 is special or
   Width                  : Integer;
   Diameter               : Integer;
   Packaging              : Boolean; // Wrap each Roll Yes/No
   Strapping_program      : Integer; // SLITTING Strapping Program 0 = None, 1..n = Banding Program
   Wrapping_Program       : Integer; // SLITTING Wrapping Pallet Cling Film Wrapping 0 = None, 1..n = Wrapping
   Ext_Wrap_program       : Integer; // EXTRUSION Wrapping Pallet Cling Film Wrapping 0 = None, 1..n = Wrapping
   Prn_Wrap_program       : Integer; // PRINTING Wrapping Pallet Cling Film Wrapping 0 = None, 1..n = Wrapping
   Lam_Wrap_program       : Integer; // LAMINATION Wrapping Pallet Cling Film Wrapping 0 = None, 1..n = Wrapping
   FFS_Wrap_program       : Integer; // FFS Wrapping Pallet Cling Film Wrapping 0 = None, 1..n = Wrapping
   Cnv_Wrap_program       : Integer; // Conversion Wrapping Pallet Cling Film Wrapping 0 = None, 1..n = Wrapping
   NGR_Wrap_Program       : Integer; // Defaults to wrap program 1, as i dont know if its Ext,prn, etc...

   Ext_zplt               : Integer; // Extrusion Pallet Type
   Prn_zplt               : Integer; // Printing Pallet Type
   Lam_zplt               : Integer; // Lamination Pallet Type
   Slt_zplt               : Integer; // Slitting Pallet Type
   ffs_zplt               : Integer; // ffs Pallet Type
   cnv_zplt               : Integer; // Conversion Pallet Type
   NGR_zplt               : INteger; // NGR Pallet type

   Label_Side_1        : Boolean;
   LabelOrientation_1  : Boolean;
   Label_Side_2        : Boolean;
   LabelOrientation_2  : Boolean;
   Label_Side_3        : Boolean;
   LabelOrientation_3  : Boolean;
   Label_Side_4        : Boolean;
   LabelOrientation_4  : Boolean;
   Final_ZPSTATE       : Integer;  // Final Pallet State
  end;

 type

  TClientConfigurationEventHandlers130 = class
    // Colins Handler for exposing all the OPC failures , for Certificates etc, deep in OPC System
    procedure OnLogEntry(ASender: TObject; sender: OleVariant; const eventArgs: _LogEntryEventArgs);
  end;

  TFormMain_Koch = class(TForm)
    AdvPanel1: TAdvPanel;
    Timer_Watchdog: TTimer;
    ppReport1: TppReport;
    ppDetailBand1: TppDetailBand;
    ppLabel1: TppLabel;
    ppShape1: TppShape;
    ppShape2: TppShape;
    ppShape3: TppShape;
    ppShape4: TppShape;
    ppShape5: TppShape;
    ppShape6: TppShape;
    ppShape7: TppShape;
    ppShape8: TppShape;
    ppDesignLayers1: TppDesignLayers;
    ppDesignLayer1: TppDesignLayer;
    ppParameterList1: TppParameterList;
    ppJITPipeline1: TppJITPipeline;
    AdvPanel2: TAdvPanel;
    AdvPanel3: TAdvPanel;
    AdvGlowButton_CANCEL: TAdvGlowButton;
    UniQuerySQL: TUniQuery;
    UniTransactionKochMain: TUniTransaction;
    UniQueryCoreCreate: TUniQuery;
    AdvGlowButtonPrinterSetup: TAdvGlowButton;
    AdvGlowButton2: TAdvGlowButton;
    AdvGlowButtonLicence: TAdvGlowButton;
    AdvLabel1: TAdvLabel;
    AdvMultiInputQueryDialog1: TAdvMultiInputQueryDialog;
    AdvPanel4: TAdvPanel;
    MemoJobs: TMemo;
    Image_SmallKochLayout: TImage;
    Label_Core_Label: TLabel;
    Label_Outer_Roll: TLabel;
    Label_Main_Pallet: TLabel;
    Label_Pallet_ID: TLabel;
    Label_Standby_Printer: TLabel;
    AdvPanel5: TAdvPanel;
    AdvGlowButton1: TAdvGlowButton;
    AdvSmoothSliderTimer: TAdvSmoothSlider;
    Label2: TLabel;
    Panel1: TPanel;
    ShapeAlive: TShape;
    Label1: TLabel;
    Label_PLClastComms: TLabel;
    Label4: TLabel;
    AdvToolBarContainer1: TAdvToolBarContainer;
    LabelPROGRAMVERSION: TLabel;
    Label5: TLabel;
    LabelUpdateRequired: TLabel;
    AdvGlowButtonInnerRoll: TAdvGlowButton;
    AdvGlowButtonOuterRoll: TAdvGlowButton;
    AdvGlowButtonPalletMain: TAdvGlowButton;
    AdvGlowButtonPalletID: TAdvGlowButton;
    AdvGlowButtonStandBy: TAdvGlowButton;
    CheckBoxFullDebug: TCheckBox;
    AdvGlowButton5: TAdvGlowButton;
    AdvMultiInputQueryDialogDelete: TAdvMultiInputQueryDialog;
    FontDialog1: TFontDialog;
    AdvGlowButtonSetFont: TAdvGlowButton;
    AdvPanel6: TAdvPanel;
    Label3: TLabel;
    AdvGridDropDownReadNames: TAdvGridDropDown;
    AdvGlowButton_MANUAL_READ: TAdvGlowButton;
    AdvGlowButton_MANUAL_SEND: TAdvGlowButton;
    EditTXValue: TEdit;
    AdvGridDropDownWriteNames: TAdvGridDropDown;
    AdvGlowButtonClearLog: TAdvGlowButton;
    Memo_Debug: TMemo;
    VrLabelHeartBeat: TVrLabel;
    Label6: TLabel;
    Timer_DB_Connection: TTimer;
    TimerAUTOSTART: TTimer;
    AdvGlowButton3: TAdvGlowButton;
    procedure OnDataChangeNotification( ASender: TObject;  // <<< main Call back event OPC
                                        sender: OleVariant;
                                        const eventArgs: EasyUADataChangeNotificationEventArgs);
    procedure FormCreate(Sender: TObject);
    procedure AdvGlowButton_CANCELClick(Sender: TObject);
    procedure AdvGlowButton2Click(Sender: TObject);
    procedure AdvGlowButtonPrinterSetupClick(Sender: TObject);
    procedure Timer_WatchdogTimer(Sender: TObject);
    procedure AdvGlowButtonLicenceClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AdvSmoothSliderTimerStateChanged(Sender: TObject;
      State: TAdvSmoothSliderState; Value: Double);
    procedure AdvGlowButton_MANUAL_SENDClick(Sender: TObject);
    procedure AdvGlowButton_MANUAL_READClick(Sender: TObject);
    procedure Label_Standby_PrinterDblClick(Sender: TObject);
    procedure Label_Pallet_IDDblClick(Sender: TObject);
    procedure Label_Main_PalletDblClick(Sender: TObject);
    procedure Label_Outer_RollDblClick(Sender: TObject);
    procedure Label_Core_LabelDblClick(Sender: TObject);
    procedure AdvGlowButtonStandByClick(Sender: TObject);
    procedure AdvGlowButtonPalletIDClick(Sender: TObject);
    procedure AdvGlowButtonPalletMainClick(Sender: TObject);
    procedure AdvGlowButtonOuterRollClick(Sender: TObject);
    procedure AdvGlowButtonInnerRollClick(Sender: TObject);
    procedure AdvGlowButton5Click(Sender: TObject);
    procedure AdvGlowButtonSetFontClick(Sender: TObject);
    procedure AdvGlowButtonClearLogClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer_DB_ConnectionTimer(Sender: TObject);
    procedure TimerAUTOSTARTTimer(Sender: TObject);
    procedure AdvGlowButton3Click(Sender: TObject);
  private
    { Private declarations }
    KillSystem : Boolean;
    WaitingFor_RequestDataToDrop           : Boolean;
    WaitingFor_CreateRollToDrop            : Boolean;
    WaitingFor_RequestCorePrintToDrop      : Boolean;
    WaitingFor_MasterRollPalletSentToDrop  : Boolean;
    WaitingFor_ExternalRollPrintDrop       : Boolean;
    WaitingFor_PalletIDPrintToDrop         : Boolean;
    WaitingFor_A5PalletPrintToDrop         : Boolean;
    Request_to_Reconnect                   : Boolean;


    procedure AddListener(DataPoint: String);
    procedure ProcessKochError;
    procedure FetchorderDataFromKochInfo;       // *****  Fetch Flags and Send to Koch
    function  ReadNodeValue(Node: String): OleVariant;
    procedure WriteNodeValue(Node: String; WriteValue: OleVariant);
    procedure RequestDataOrderStartDB4100;      //  ***** SEND TO KOCH
    procedure Handle_MasterRoll_Event_DB4123;   // Master Roll Request Handler

    procedure PrintLabelCoreDB4102;             // Core Label Print routine
    procedure PrintOutSideLabelDB4111;          // External Roll label Print routine
    procedure Print_Pallet_Block_ID_LabelDB4124;

//    procedure Run_Start_Order_Thread;

    procedure CreateNew_Slitting_Roll(const zword     : Integer;
                                      const zm        : Integer;
                                      const AuditNO   : Integer;
                                      const audittime : TDateTime;
                                      const weight    : Double;
                                      const length    : Double;
                                      var zpallet     : Integer;
                                      var zpitem      : Integer ) ;

    function Read_Boolean_Value(NodeName: String): Boolean;
    function Read_Float_Value(NodeName: String): Double;
    function Read_Int_Value(NodeName: String): Integer;
//    Function Read_DateTime_Value(NodeName:String; var sHex:String): TDateTime;

    Function FetchWorksOrderData(const izword         : integer;
//                                            const izm            : integer;
                                            const izclock        : Integer;
                                            var   OrderStructure : TOrderInfo ): Integer;

    procedure StartSystem;

    Procedure CreateRoll(const iAuditNo   : integer;
                                    const Auditdate  : TDateTime;
                                    const zword      : Integer;
                                    const rweight    : Double;
                                    const rlength    : Double;
                                    const izclock    : Integer;
                                    var   zpallet    : Integer;
                                    var   zpitem     : Integer;
                                    const izm        : Integer);
    Procedure Print_Core_Label_DB4102(const zpallet :integer; const zpitm :integer ;const sTargetPrinter :String);
    procedure RUN_WeighAdmin;
    procedure Create_Label_Core_DB4102;
    Function  Fetch_Word_For_zpallet(const zpallet   :Integer;
                                               var zpstate     :integer;
                                               var final_State :Integer;
                                               var zplt        :integer ): integer;
    function  Fetch_Pallet_For_zpitm(const zpitm: Integer): integer;
    Procedure Print_Pallet_ID_Label_DB4124(iZPallet: Integer; KochPalletIDPrinterName: String);
    Procedure Print_A5_Label_DB4125(ZPallet                     :Integer;
                                               iPrintSide                  :Integer;
                                               Selected_Koch_Pallet_A5_PrinterName :String;
                                               var iError                  :Integer);
    procedure Print_A5_Pallet_Label_DB4125;
    procedure FillReadnamedropdown;
    function  Fetch_Running_Koch_Jobs(const izword :integer;
                                                var  zclock  :Integer;
                                                var  zm      :Integer): Boolean;
    procedure SendTestpageTo_A5(const sTargetPrinter :String);
    procedure SendTestpageTo_SmallPrinter(const sTargetPrinter: String);
    procedure Delete_A_Roll;
//    function IsFinished_Goods(const zpallet, zpstate: Integer): Boolean; // Fetch 6 jobs Clockno, machine, worksorder

    procedure Debug_Logging(sMessage: String ; lineColour:TColor);
    Function  Koch_Pallet_Translate(zplt_in:integer):Integer;
    function OpenOPCcomms: Boolean;

  public
    { Public declarations }
    Counterr  : Integer;
    LastMil   : Integer;
    GlobalAutoStart :Boolean;
    AlreadyStarted :Boolean;

  end;


var   // SYSTEM GLOBAL VARIABLES
  FormMain_Koch   : TFormMain_Koch;
  Client          : TEasyUAClient;    //ORIGINAL MARCH
  Endpoint        : String;   // Actual Address IP:Port of PLC
// Org Code   ClientConfiguration                : OpcLabs_EasyOpcUA_TLB.TEasyUAClientConfiguration;  // Debug OPC Class Error Capture..Yuch!!
  ClientConfiguration                : OpcLabs_EasyOpcUA_TLB.TEasyUAClientManagement;  // Debug OPC Class Error Capture..Yuch!!
  ClientConfigurationEventHandlers   : TClientConfigurationEventHandlers130;              // Debug OPC Class Error Capture..Yuch!!

  CONST
   K_LOGGING          = TRUE;

  // D4100 Block first block
   K_DB4100_Main_SIVA_MIS_status           = '"DB4100_Main"."Receive"."SIVA_MIS_Status"';   // Data to Koch
   K_DB4100_Main_data_send                 = '"DB4100_Main"."Receive"."Data_Send"';         // Data to Koch
   K_DB4100_Main_request_Data              = '"DB4100_Main"."Send"."Request_Data"';         // Data From Koch
   K_DB4100_Main_Error_flag                = '"DB4100_Main"."Send"."Error_Flag"';           //       "
   K_DB4100_Main_Error_Code                = '"DB4100_Main"."Send"."Error_Code"';           //       "
   K_DB4100_Main_status                    = '"DB4100_Main"."Send"."Status"';               //       "
   K_DB4100_Main_Employee_No               = '"DB4100_Main"."Send"."Employee_No"';          //       "
   K_DB4100_Main_Worksorder_No             = '"DB4100_Main"."Send"."Worksorder_No"';        //       "
   K_DB4100_Main_Machine_No                = '"DB4100_Main"."Send"."Machine_No"';           //       "

  // D4101 CORE LABEL Block First Core label request
   K_DB4101_Core_Labeling_Roll_No          = '"DB4101_Core_Labeling"."Receive"."Reel_No"';     // Sent TO Koch
   K_DB4101_Core_Labeling_Pallet_No        = '"DB4101_Core_Labeling"."Receive"."Pallet_No"';   // Sent TO Koch
   K_DB4101_Core_Labeling_audit_no         = '"DB4101_Core_Labeling"."Send"."Audit_No"';       // Receive From Koch
   K_DB4101_Core_Labeling_Audit_timestamp  = '"DB4101_Core_Labeling"."Send"."Audit_Timestamp"';//    "
   K_DB4101_Core_Labeling_Worksorder_No    = '"DB4101_Core_Labeling"."Send"."Worksorder_No"';  //    "
   K_DB4101_Core_Labeling_Weight           = '"DB4101_Core_Labeling"."Send"."Weight"';         //    "
   K_DB4101_Core_Labeling_length           = '"DB4101_Core_Labeling"."Send"."Length"';         //    "
   K_DB4101_Core_Labeling_CoreRoll         = '"DB4101_Core_Labeling"."Send"."Reel_No"';        //    "
   K_DB4101_Core_Labeling_CreateRoll       = '"DB4101_Core_Labeling"."Send"."Create_Roll"';    // TRIGGER !!!    "
   K_DB4101_Core_Labeling_Print_label      = '"DB4101_Core_Labeling"."Send"."Print_Label"';    // TRIGGER !!! Print the actual Core label NOW....


  // D4102 JOB DATA Block sent when DB4000 is received
   K_DB4102_Job_data_Rolls_per_Layer       = '"DB4102_Job_Data"."Rolls_Per_Layer"';         // Data to Koch
   K_DB4102_Job_data_Layers_Per_Pallet     = '"DB4102_Job_Data"."Layer_Per_Pallet"';        // Data to Koch
   K_DB4102_Job_data_Type_Of_Pallet        = '"DB4102_Job_Data"."Type_Of_Pallet"';          // Data to Koch
   K_DB4102_Job_data_Pattern               = '"DB4102_Job_Data"."Pattern"';                 // Data to Koch If Pattern = 0 then slit and eject b4 palletize
   K_DB4102_Job_data_Cutting_width         = '"DB4102_Job_Data"."Cutting_Width"';           // Data to Koch
   K_DB4102_Job_data_Diameter              = '"DB4102_Job_Data"."Diameter"';                // Data to Koch *** NOT USED  *** Always sends 0.0 to Koch (ours is a guess)
   K_DB4102_Job_data_Wrapping_program      = '"DB4102_Job_Data"."Wrapping_Program"';        // Data to Koch New 0=No Clingfilm Wrap , 1..n = Pallet Wrap
   K_DB4102_Job_data_Strapping_program     = '"DB4102_Job_Data"."Strapping_Program"';       // Data to Koch New 0=No Banding of Rolls , 1= strapping
   K_DB4102_Job_data_packaging             = '"DB4102_Job_Data"."Packaging"';               // Data to Koch Roll Packaging (Individual Roll Wrapping)
   K_DB4102_Job_data_Label_Side1           = '"DB4102_Job_Data"."Label_Side_1"';            // Data to Koch
   K_DB4102_Job_data_Label_orientation_1   = '"DB4102_Job_Data"."Label_Orientation_1"';     // Data to Koch
   K_DB4102_Job_data_Label_Side2           = '"DB4102_Job_Data"."Label_Side_2"';            // Data to Koch
   K_DB4102_Job_data_Label_orientation_2   = '"DB4102_Job_Data"."Label_Orientation_2"';     // Data to Koch
   K_DB4102_Job_data_Label_Side3           = '"DB4102_Job_Data"."Label_Side_3"';            // Data to Koch
   K_DB4102_Job_data_Label_orientation_3   = '"DB4102_Job_Data"."Label_Orientation_3"';     // Data to Koch
   K_DB4102_Job_data_Label_Side4           = '"DB4102_Job_Data"."Label_Side_4"';            // Data to Koch
   K_DB4102_Job_data_Label_orientation_4   = '"DB4102_Job_Data"."Label_Orientation_4"';     // Data to Koch



  // DB4103 Order data for each job
   K_DB4103_Order_Data_EmployeeNoL1        = '"DB4103_Order_Data"."Employee_No_L1"';
   K_DB4103_Order_Data_WorksorderNoL1      = '"DB4103_Order_Data"."Worksorder_No_L1"';
   K_DB4103_Order_Data_MachineNoL1         = '"DB4103_Order_Data"."Machine_No_L1"';
   K_DB4103_Order_Data_EmployeeNoL2        = '"DB4103_Order_Data"."Employee_No_L2"';
   K_DB4103_Order_Data_WorksorderNoL2      = '"DB4103_Order_Data"."Worksorder_No_L2"';
   K_DB4103_Order_Data_MachineNoL2         = '"DB4103_Order_Data"."Machine_No_L2"';
   K_DB4103_Order_Data_EmployeeNoL3        = '"DB4103_Order_Data"."Employee_No_L3"';
   K_DB4103_Order_Data_WorksorderNoL3      = '"DB4103_Order_Data"."Worksorder_No_L3"';
   K_DB4103_Order_Data_MachineNoL3         = '"DB4103_Order_Data"."Machine_No_L3"';
   K_DB4103_Order_Data_EmployeeNoL4        = '"DB4103_Order_Data"."Employee_No_L4"';
   K_DB4103_Order_Data_WorksorderNoL4      = '"DB4103_Order_Data"."Worksorder_No_L4"';
   K_DB4103_Order_Data_MachineNoL4         = '"DB4103_Order_Data"."Machine_No_L4"';
   K_DB4103_Order_Data_EmployeeNoL5        = '"DB4103_Order_Data"."Employee_No_L5"';
   K_DB4103_Order_Data_WorksorderNoL5      = '"DB4103_Order_Data"."Worksorder_No_L5"';
   K_DB4103_Order_Data_MachineNoL5         = '"DB4103_Order_Data"."Machine_No_L5"';
   K_DB4103_Order_Data_EmployeeNoL6        = '"DB4103_Order_Data"."Employee_No_L6"';
   K_DB4103_Order_Data_WorksorderNoL6      = '"DB4103_Order_Data"."Worksorder_No_L6"';
   K_DB4103_Order_Data_MachineNoL6         = '"DB4103_Order_Data"."Machine_No_L6"';

  // DB4111 Block  Outside Core label
   K_DB4111_Outside_label_Roll_No          = '"DB4111_Outside_Label"."Roll_No"';
   K_DB4111_Outside_label_Print_label      = '"DB4111_Outside_Label"."Print_Label"';

  // DB4123 Block Master roll request from Koch
   K_DB4123_MasterRoll_Number_Good         = '"DB4123_Masterroll"."Receive"."Number_Good"';
   K_DB4123_MasterRoll_typ_of_pallet       = '"DB4123_Masterroll"."Receive"."Type_Of_Pallet"';
   K_DB4123_Masterroll_Label_Side1         = '"DB4123_Masterroll"."Receive"."Label_Side_1"';            // Data to Koch
   K_DB4123_Masterroll_Label_orientation_1 = '"DB4123_Masterroll"."Receive"."Label_Orientation_1"';     // Data to Koch
   K_DB4123_Masterroll_Label_Side2         = '"DB4123_Masterroll"."Receive"."Label_Side_2"';            // Data to Koch
   K_DB4123_Masterroll_Label_orientation_2 = '"DB4123_Masterroll"."Receive"."Label_Orientation_2"';     // Data to Koch
   K_DB4123_Masterroll_Label_Side3         = '"DB4123_Masterroll"."Receive"."Label_Side_3"';            // Data to Koch
   K_DB4123_Masterroll_Label_orientation_3 = '"DB4123_Masterroll"."Receive"."Label_Orientation_3"';     // Data to Koch
   K_DB4123_Masterroll_Label_Side4         = '"DB4123_Masterroll"."Receive"."Label_Side_4"';            // Data to Koch
   K_DB4123_Masterroll_Label_orientation_4 = '"DB4123_Masterroll"."Receive"."Label_Orientation_4"';     // Data to Koch
   K_DB4123_MasterRoll_Wrapping_program    = '"DB4123_Masterroll"."Receive"."Wrapping_Program"';        // Data to Koch ** NEW CLING FILM PROGRAM ***
   K_DB4123_MasterRoll_Done                = '"DB4123_Masterroll"."Receive"."Done"';
   K_DB4123_MasterRoll_Error               = '"DB4123_Masterroll"."Receive"."Error"';
   K_DB4123_MasterRoll_Pallet_No           = '"DB4123_Masterroll"."Send"."Pallet_No"';
   K_DB4123_MasterRoll_Pallet_Lookup       = '"DB4123_Masterroll"."Send"."Pallet_Lookup"';                // TRIGGER to check pallet data

  // DB4124 Block Pallet ID Block label  ./.. Only Called for Normal Pallets   NOT MASTERROLL Pallets
   K_DB4124_Block_label_Pallet_No          = '"DB4124_Block_Label"."Pallet_No"';                          // Mater roll already have ID labels
   K_DB4124_Block_label_Print_label        = '"DB4124_Block_Label"."Print_Label"';

  // DB4125 Block Main A5 pallet labels   ... Final BIG pallet lastes per side
   K_DB4125_Pallet_label_Pallet_No         = '"DB4125_Pallet_Label"."Pallet_No"';
   K_DB4125_Pallet_label_side_of_pallet    = '"DB4125_Pallet_Label"."Side_Of_Pallet"';
   K_DB4125_Pallet_label_Print_label       = '"DB4125_Pallet_Label"."Print_Label"';
   K_DB4125_Pallet_label_Label_Printer     = '"DB4125_Pallet_Label"."Label_Printer"';


  // DB4130_Heartbeat to Koch system
   K_DB4130_Heartbeat_Sys_Time_To_MIS      = '"DB4130_Heartbeat"."Sys_Time_To_MIS"';
   K_DB4130_Heartbeat_Sys_Time_From_MIS    = '"DB4130_Heartbeat"."Sys_Time_From_MIS"';

   K_PLC_ADDRESS                           = 'opc.tcp://192.168.17.199:4840'; // On Site is 10.0.0.250:4840

implementation

{$R *.dfm}

uses Globals, SivaData , RBWeighPrint, WeighAdmin, PrintPalletID;

{ TClientConfigurationEventHandlers130 }
procedure TClientConfigurationEventHandlers130.OnLogEntry(ASender: TObject; sender: OleVariant; const eventArgs: _LogEntryEventArgs);
var
  myFile : TextFile;

begin
  AssignFile(myFile, 'c:\logs\OPC_Colin_Logs.txt');
  if fileexists('c:\logs\OPC_Colin_Logs.txt') then
    append(myFile)
  Else
    ReWrite(myFile);

  WriteLn(myFile, eventArgs.ToString);

  CloseFile(myFile);

end;



(*=============================================================================
  =============================================================================
  =================START SYSTEM AND ATTACH LISTENERS===========================
  =============================================================================
  =============================================================================
*)

Function TFormMain_Koch.OpenOPCcomms:Boolean;
var
   sConnected   : String;
  qv           : TAdvMultiInputQueryValue;
  vTargetURL,
  vTargetPort  : String;
  I  :Integer;
begin
   Result := False;
      // Default points to CBL server
   Endpoint := K_PLC_ADDRESS; // 'opc.tcp://192.168.17.199:4840'; testing at CBL address
         AdvMultiInputQueryDialog1.QueryValues.Clear;
      AdvMultiInputQueryDialog1.LabelWidth := 150;
      qv         := AdvMultiInputQueryDialog1.QueryValues.Add;
      qv.&Label  := 'Target PLC Address ?';
      qv.Name    := 'TargetURL';

      if GlobalAutoStart then
        Begin
         EndPoint := 'opc.tcp://10.0.0.250:4840'; //Location of OPC server and portnumber
        End
       Else
        Begin

          if fileexists(K_AutoLogon) then
            AdvMultiInputQueryDialog1.Values['TargetURL'].DefaultValue := 'opc.tcp://192.168.17.199' // At CBL Test
          Else
            AdvMultiInputQueryDialog1.Values['TargetURL'].DefaultValue  := 'opc.tcp://10.0.0.250'; // At Site
          qv := AdvMultiInputQueryDialog1.QueryValues.Add;
          qv.&Label := 'Target Port [4840] ?';
          qv.Name   := 'TargetPort';
          AdvMultiInputQueryDialog1.Values['TargetPort'].DefaultValue := '4840';

          if AdvMultiInputQueryDialog1.Execute(True) = MrOk then
           Begin
             vTargetURL  := AdvMultiInputQueryDialog1.Values['TargetURL'].ResultValue;
             vTargetPort := AdvMultiInputQueryDialog1.Values['TargetPort'].ResultValue;
             EndPoint    := vTargetURL + ':' + vTargetPort;
             KillSystem  := False;
           End
          Else
           begin
            KillSystem := true;
            Application.ShowMainForm := False;
            Application.Terminate;
           end;
        End;

      {New 20th March 2022 - OPC logging Handlers starting, Dumps log into c:\logs\OPC_Colin_Logs.txt file}
      Debug_Logging('Creating OPC Event Handler '+ EndPoint,ClWindow);
      ClientConfiguration               := OpcLabs_EasyOpcUA_TLB.TEasyUAClientManagement.Create(nil);
      Debug_Logging('TClientConfigurationEventHandlers130.Create '+ EndPoint,ClWindow);
      ClientConfigurationEventHandlers  := TClientConfigurationEventHandlers130.Create;
      Debug_Logging('ClientConfigurationEventHandlers.OnLogEntry; '+ EndPoint,ClWindow);
      ClientConfiguration.OnLogEntry    := ClientConfigurationEventHandlers.OnLogEntry;
      Debug_Logging('ClientConfiguration.Connect; '+ EndPoint,ClWindow);
     Try
      ClientConfiguration.Connect;

      Debug_Logging('OPC Event Handler Connected '+ EndPoint,ClWindow);
      // Ok Lets create our Client OPC inteface class
      Debug_Logging('Creating OPC Client '+ EndPoint,ClWindow);
      Client   := OpcLabs_EasyOpcUA_TLB.TEasyUAClient.Create(nil);
      Debug_Logging('OPC Client Created'+ EndPoint,ClWindow);
      Result := true;
     Except
      Showmessage('Failed to connect to finish ClientConfiguration.Connect ');
      Result := False;
     End;
end;


procedure TFormMain_Koch.FormCreate(Sender: TObject);
var
  sConnected   : String;
  qv           : TAdvMultiInputQueryValue;
  vTargetURL,
  vTargetPort  : String;
  I  :Integer;

  begin
     Request_to_Reconnect := False;
     KillSystem := False;
     AlreadyStarted := False;

     sConnected := '';
     WaitingFor_RequestDataToDrop          :=  False; // If set check Request_Data Flag, if Dropped then clear Data_Send Flag
     WaitingFor_RequestCorePrintToDrop     :=  False; // We are not printing a Core Label
     WaitingFor_MasterRollPalletSentToDrop :=  False; // Wait to clear output values are flag changes state
     WaitingFor_ExternalRollPrintDrop      :=  False; // After printing External Core label
     WaitingFor_PalletIDPrintToDrop        :=  False;
     WaitingFor_A5PalletPrintToDrop        :=  False;

      // Set up database connection

      if ParamCount > 1 then
        Begin
         if pos('-AUTOSTART',Uppercase(ParamStr(2))) > 0 then
            begin
             GlobalAutoStart  := True;
             SivaData.DMSIVADATA.AutoLoginUser    := 'SYSDBA';
             SivaData.DMSIVADATA.AutoLoginPw      := '';
             var fakepw :string;
              fakepw := 'XmDa6sTteeFr2k%e!yF*hsgsfa';
              for I := 1 to length(fakepw) do
                begin
                 if not odd(i) then   //grab even index only
                   SivaData.DMSIVADATA.AutoLoginPw     := SivaData.DMSIVADATA.AutoLoginPw  + fakepw[i];
                end;
            end
         Else
            begin
             GlobalAutoStart                      := False;
             SivaData.DMSIVADATA.AutoLoginUser    := '';
             SivaData.DMSIVADATA.AutoLoginPw      := '';
            end
        End;




     if SivaData.DMSIVADATA.ConnectToDataBase(sConnected) then
      Debug_Logging('Connected to SivaDB :' +SivaData.DMSIVADATA.UniConnectionMain.Database+'   '+ SConnected,ClWindow)
     else
      Debug_Logging('*******  NOT Connected to SivaDB  *******',clWebSalmon);

      Timer_DB_Connection.Enabled := true; // Start Auto drop connection



      // Default points to CBL server
      Endpoint := K_PLC_ADDRESS; // 'opc.tcp://192.168.17.199:4840'; testing at CBL address

      LoadWeighRegistryValues;

      // Need to do this to get the GTIN config details from the Config Table
      UNI_LoadConfigDetails(UniTransactionKochMain,DMSIVADATA.UniConnectionMain);


//      AdvMultiInputQueryDialog1.QueryValues.Clear;
//      AdvMultiInputQueryDialog1.LabelWidth := 150;
//      qv         := AdvMultiInputQueryDialog1.QueryValues.Add;
//      qv.&Label  := 'Target PLC Address ?';
//      qv.Name    := 'TargetURL';
//
//      if GlobalAutoStart then
//        Begin
//         EndPoint := 'opc.tcp://10.0.0.250:4840'; //Location of OPC server and portnumber
//        End
//       Else
//        Begin
//
//          if fileexists(K_AutoLogon) then
//            AdvMultiInputQueryDialog1.Values['TargetURL'].DefaultValue := 'opc.tcp://192.168.17.199' // At CBL Test
//          Else
//            AdvMultiInputQueryDialog1.Values['TargetURL'].DefaultValue  := 'opc.tcp://10.0.0.250'; // At Site
//          qv := AdvMultiInputQueryDialog1.QueryValues.Add;
//          qv.&Label := 'Target Port [4840] ?';
//          qv.Name   := 'TargetPort';
//          AdvMultiInputQueryDialog1.Values['TargetPort'].DefaultValue := '4840';
//
//          if AdvMultiInputQueryDialog1.Execute(True) = MrOk then
//           Begin
//             vTargetURL  := AdvMultiInputQueryDialog1.Values['TargetURL'].ResultValue;
//             vTargetPort := AdvMultiInputQueryDialog1.Values['TargetPort'].ResultValue;
//             EndPoint    := vTargetURL + ':' + vTargetPort;
//             KillSystem  := False;
//           End
//          Else
//           begin
//            KillSystem := true;
//            Application.ShowMainForm := False;
//            Application.Terminate;
//           end;
//        End;

{
20 Sep 16:17:11: *******  NOT Connected to SivaDB  *******
20 Sep 16:17:14: Creating OPC Event Handler opc.tcp://10.0.0.250:4840
20 Sep 16:17:14: TClientConfigurationEventHandlers130.Create opc.tcp://10.0.0.250:4840
20 Sep 16:17:14: ClientConfigurationEventHandlers.OnLogEntry; opc.tcp://10.0.0.250:4840
20 Sep 16:17:14: ClientConfiguration.Connect; opc.tcp://10.0.0.250:4840
CRASH !!!!
      Faulting application name: Koch195xx.exe, version: 180.0.0.0, time stamp: 0x650b0c12
      Faulting module name: clr.dll, version: 4.8.9181.0, time stamp: 0x64b8594f
      Exception code: 0xc00000fd
      Fault offset: 0x0045939a
      Faulting process ID: 0x0x1EC4
      Faulting application start time: 0x0x1D9EBD57DD39F24
      Faulting application path: C:\Users\$admin\Desktop\KochSys\Koch195xx.exe
      Faulting module path: C:\Windows\Microsoft.NET\Framework\v4.0.30319\clr.dll
      Report ID: 5897292f-ae8c-4fba-b2d6-011b9f63b4b2
      Faulting package full name:

}


//      {New 20th March 2022 - OPC logging Handlers starting, Dumps log into c:\logs\OPC_Colin_Logs.txt file}
//      Debug_Logging('Creating OPC Event Handler '+ EndPoint,ClWindow);
//      ClientConfiguration               := OpcLabs_EasyOpcUA_TLB.TEasyUAClientManagement.Create(nil);
//      Debug_Logging('TClientConfigurationEventHandlers130.Create '+ EndPoint,ClWindow);
//      ClientConfigurationEventHandlers  := TClientConfigurationEventHandlers130.Create;
//      Debug_Logging('ClientConfigurationEventHandlers.OnLogEntry; '+ EndPoint,ClWindow);
//      ClientConfiguration.OnLogEntry    := ClientConfigurationEventHandlers.OnLogEntry;
//      Debug_Logging('ClientConfiguration.Connect; '+ EndPoint,ClWindow);
//     Try
//      ClientConfiguration.Connect;
//     Except
//      Showmessage('Failed to connect to finish ClientConfiguration.Connect ');
//     End;
//      Debug_Logging('OPC Event Handler Connected '+ EndPoint,ClWindow);
//      // Ok Lets create our Client OPC inteface class
//      Debug_Logging('Creating OPC Client '+ EndPoint,ClWindow);
//      Client   := OpcLabs_EasyOpcUA_TLB.TEasyUAClient.Create(nil);
//      Debug_Logging('OPC Client Created'+ EndPoint,ClWindow);

//      if not OpenOPCcomms then
//       Begin
//         Showmessage('Failed to Connect to Koch PLC');
//         Exit;
//       End;


      Counterr := 0;

      LastMil  := MillisecondOfTheDay(Now);

      Image_SmallKochLayout.Picture.LoadFromFile('SmallKochLayout.png');

      FillReadNameDropDown;

      Memo_debug.lines.add('');


     if GlobalAutoStart then
       Begin
        TimerAUTOSTART.enabled := True;  // Presses Start button after 5 seconds once only
        Debug_Logging('*******  LIFT OFF  ---  AUTOSTARTING CONNECTION  ************',ClWindow);
       End
     else
        Debug_Logging('*******  LIFT OFF  ---  PRESS START  ************',ClWindow);
end;




procedure TFormMain_Koch.FormDestroy(Sender: TObject);
begin
  // Clean up Event logging handlers started in on Form Create
   Timer_DB_Connection.Enabled := False; // Stop auto kill Db timer
  FreeAndNil(ClientConfiguration);
  FreeAndNil(ClientConfigurationEventHandlers);
end;

procedure TFormMain_Koch.StartSystem;
begin
  Debug_Logging('Starting System...',ClWindow);

  Client.OnDataChangeNotification := nil; // Disconnect callback Routine

  Debug_Logging('OnDataChange Handler cleared...',ClWindow);
  Debug_Logging('',ClWindow);
  Client.UnsubscribeAllMonitoredItems;    // Drop all Listeners
  Debug_Logging('...',ClWindow);
  Debug_Logging('',ClWindow);


  //Set the data change procedure to our custom made one.
  Client.OnDataChangeNotification := OnDataChangeNotification;

  //Create Primary Stage 1 Listerner
  AddListener(K_DB4100_Main_request_Data);

  // Stage 1 Error flag detection listener
  AddListener(K_DB4100_Main_Error_flag);

  // Stage 2 Pallet Create/Select Pallet and Create new roll for Internal Core
  AddListener(K_DB4101_Core_Labeling_CreateRoll);

  // Stage 3 Print Internal Core Label
  AddListener(K_DB4101_Core_Labeling_Print_label);

  // Stage 4 Print external roll Label
  AddListener(K_DB4111_Outside_label_Print_label);

  // Stage 5 Master roll Pallet ID Lookup
  AddListener(K_DB4123_MasterRoll_Pallet_Lookup);

  // Stage 6 Print ID Block Label for Pallet ... NOT called for Master Rolls !!!!
  AddListener(K_DB4124_Block_label_Print_label);

  ///Stage 7 Print A5 Master pallet 4 sides labels ...
  AddListener(K_DB4125_Pallet_label_Print_label);

  ///Stage 8 Print Heartbeat to/from Koch ...
  AddListener(K_DB4130_Heartbeat_Sys_Time_To_MIS);

  Debug_Logging('Listeners Added and running...',clWindow);

end;

procedure TFormMain_Koch.TimerAUTOSTARTTimer(Sender: TObject);
begin
    if (GlobalAutoStart and AlreadyStarted = False) then
      Begin
       StartSystem;
       Timer_Watchdog.Enabled := ( AdvSmoothSliderTimer.State = ssOn) ; // Added 5th Feb 2022
       AlreadyStarted := True; // Stop trying to restart each time the form shows again.
       TimerAUTOSTART.Enabled := False;
       Memo_debug.lines.add('');
       Debug_Logging('*******  AUTO STARTED SYSTEM ************',ClWindow);
      End; // Autostart

end;

procedure TFormMain_Koch.Timer_DB_ConnectionTimer(Sender: TObject);
begin
{ If database is connected
  And we have set started Flag
  and time is triggered, then Set Request_to_Reconnect flag
  This is used in the event handler BEFORE processing any events
  to ensure an event is not handled when we have a disconnected DB,
}
 Request_to_Reconnect := True;
end;

procedure TFormMain_Koch.Timer_WatchdogTimer(Sender: TObject);
// This is used to check we still have a connection to the Koch system
// and display in a coloured box on screen
var
 Errorcode :String;
 ReadFailure : Boolean;
begin

 Timer_Watchdog.enabled := false;

 ReadFailure := False;
 try
   ErrorCode :=  ReadNodeValue(K_DB4100_Main_Error_Code);
 Except
  ReadFailure := True;
 end;

 if readFailure then
   ShapeAlive.Brush.Color := clred
 else
   ShapeAlive.Brush.Color := cllime;

 if (ShapeAlive.Shape = stRectangle) then
   ShapeAlive.Shape := stCircle
  Else
   ShapeAlive.Shape := stRectangle;

 Label_PLClastComms.Caption := FormatDateTime('ddd dd mm yyyy hh:nn:ss',now);

 Timer_Watchdog.enabled := (AdvSmoothSliderTimer.State = ssOn) ;
end;

(*===========================================================================
=============================================================================
=============================================================================
=============================================================================
=============================================================================
*)
//=================================================================================
//=====================MAIN EVENT HANDLER FOR OPC==================================
//=================================================================================
//=================================================================================

procedure TFormMain_Koch.OnDataChangeNotification(ASender: TObject; sender: OleVariant;
  const eventArgs: EasyUADataChangeNotificationEventArgs);
var
  Value     : String;
  NodeName  : String;
  iHB       : Integer;
begin
  // New 5th Feb 2023 drop DB connection every 10 mins   *****  NEEDS TESTING ******
  if Request_to_Reconnect then
   begin
     Timer_DB_Connection.Enabled := false; // Stop the clock
     Request_to_Reconnect        := false;
 //    SivaData.DMSIVADATA.UniConnectionMain.Disconnect;  // flush all Transactions
 //    SivaData.DMSIVADATA.UniConnectionMain.Connect;     // restart
     Timer_DB_Connection.Enabled := True; // Start the clock
   end;


  //Fetch the Node Name and Node Value , Ie What Node and What Variable changed
  // I think that the Trigger system is not case sensative, this causes the trigger
  // to be called, but the EventArgs is case sensative, and then cause the system to fail
  // when asking for the nodename eventargs
  NodeName   := eventArgs.Arguments.NodeDescriptor.NodeId.StringIdentifier;
  if ((nodename = '') OR (NOT (Assigned(eventArgs.AttributeData)))  ) then
   Exit;

  Value      := Uppercase(Trim(eventArgs.AttributeData.DisplayValue));

  if (NodeName <> K_DB4130_Heartbeat_Sys_Time_To_MIS ) then // Heartbeat Clock update
   begin // Dont put heartbeats in logfile.
    if CheckBoxFullDebug.checked then
     Debug_Logging('NodeName = '+NOdeName + 'Value = ' + Value,ClWindow);
   end;

  //Check the Node Name - We Will Handle The Main Routines First
  //==========================================================================
  //=======================START COMMS EVENT==================================
  //===============HANDLER FOR ALL RETURNED EVENTS============================
  //==========================================================================

  if (NodeName = K_DB4100_Main_request_Data) then // First Job Request event ? .....1St Contact
   begin
    if (Value = 'TRUE')  then
      Begin
       RequestDataOrderStartDB4100;
       WaitingFor_RequestDataToDrop := true;
       if CheckBoxFullDebug.checked then
         Debug_Logging('WaitingFor_RequestDataToDrop is set',ClWindow);

      End
    else
     if WaitingFor_RequestDataToDrop then
      begin
       WriteNodeValue(K_DB4100_Main_data_send,False); // Reset my Sent data Flag
       WaitingFor_RequestDataToDrop := False;
       if CheckBoxFullDebug.checked then
         begin
          Debug_Logging('WaitingFor_RequestDataToDrop is CLEARED',ClWindow);
          Debug_Logging('',ClWindow);
         end;
      end
   end
  else
  //==========================================================================
  //=================ERROR COMMS EVENT========================================
  //==========================================================================
  //==========================================================================

  if NodeName = K_DB4100_Main_Error_flag then // Error Flag in Main Request Triggered
    begin
      if Value = 'TRUE'  then  //  ******   PLC has Set ERROR Status  *******
        ProcessKochError;
    end
  else
  //==========================================================================
  //=================   1st CREATE PALLET / CORE EVENT   =====================
  //==================== CREATE PALLET AND CORE ==============================
  //==========================================================================

    if NodeName = K_DB4101_Core_Labeling_CreateRoll then // First Core label request
     begin
      if ((Value = 'TRUE') and (WaitingFor_CreateRollToDrop = False))  then
          begin
            Create_Label_Core_DB4102;
            WaitingFor_CreateRollToDrop := True;
            if CheckBoxFullDebug.checked then
               Debug_Logging('WaitingFor_CreateRollToDrop is set',ClWindow);
          end
      else
        if ((Value = 'FALSE') and (WaitingFor_CreateRollToDrop = True)) then
         Begin
           WriteNodeValue(K_DB4101_Core_Labeling_Roll_No,0);   // Reset Core Id
           WriteNodeValue(K_DB4101_Core_Labeling_Pallet_No,0); // Reset Pallet No
           WaitingFor_CreateRollToDrop := False;
           if CheckBoxFullDebug.checked then
             Begin
              Debug_Logging('WaitingFor_CreateRollToDrop is CLEARED',ClWindow);
              Debug_Logging('',ClWindow);
             End;

          End;

     end
  //==========================================================================
  //=================   1st CORE LABEL PRINTING  =============================
  //==========================================================================
  //==========================================================================
    Else
    if NodeName = K_DB4101_Core_Labeling_Print_label then // First Core label request
     begin
     if ((Value = 'TRUE') and (WaitingFor_RequestCorePrintToDrop =  False)) then
       begin
         PrintLabelCoreDB4102;
         WaitingFor_RequestCorePrintToDrop := True;
         Label_Core_Label.Color := clLime;
         if CheckBoxFullDebug.checked then
             Debug_Logging('WaitingFor_RequestCorePrintToDrop is set',ClWindow);
       end
     else
       if (Value = 'FALSE') AND (WaitingFor_RequestCorePrintToDrop = true) then
         begin
          WaitingFor_RequestCorePrintToDrop := false;
          Label_Core_Label.Color := clYellow;
          if CheckBoxFullDebug.checked then
           Begin
             Debug_Logging('WaitingFor_RequestCorePrintToDrop is CLEARED',ClWindow);
             Debug_Logging('',ClWindow);
           End;

         end;

     end
  else
  //==========================================================================
  //================= OUTSIDE ROLL LABEL EVENT================================
  //====================CREATE PALLET AND CORE ===============================
  //==========================================================================
   if (NodeName = K_DB4111_Outside_label_Print_label) then // Outside label Request
    begin
     if ((Value = 'TRUE') and (WaitingFor_ExternalRollPrintDrop = False))  then
      begin
        PrintOutSideLabelDB4111 ; // Print External roll labels
        WaitingFor_ExternalRollPrintDrop := True;
        Label_Outer_Roll.Color := clLime;
        if CheckBoxFullDebug.checked then
          Debug_Logging('WaitingFor_ExternalRollPrintDrop is set',ClWindow);

      end
     else
      begin
        if ((Value = 'FALSE') AND ( WaitingFor_ExternalRollPrintDrop = true)) then
         begin
           WaitingFor_ExternalRollPrintDrop := False;
           Label_Outer_Roll.Color           := clYellow;
           if CheckBoxFullDebug.checked then
            Begin
              Debug_Logging('WaitingFor_ExternalRollPrintDrop is CLEARED',ClWindow);
              Debug_Logging('',ClWindow);
            End;
         end;
      end;
    end
  else
  //==========================================================================
  //================= PRINT PALLET ID BLOCK EVENT ===========================
  //==========================================================================
  //==========================================================================
if (NodeName = K_DB4124_Block_label_Print_label) then // Outside label Request
    begin
     if ((Value = 'TRUE') and (WaitingFor_PalletIDPrintToDrop = False))  then
      begin
        Print_Pallet_Block_ID_LabelDB4124 ; // Print Pallet Block ID labels
        WaitingFor_PalletIDPrintToDrop := True;
        Label_Pallet_ID.Color := clLime;
        if CheckBoxFullDebug.checked then
          Debug_Logging('WaitingFor_PalletIDPrintToDrop is Set',ClWindow);
      end
     else
      begin
        if ((Value = 'FALSE') AND ( WaitingFor_PalletIDPrintToDrop = true)) then
         begin
           WaitingFor_PalletIDPrintToDrop := False;
           Label_Pallet_ID.Color := clYellow;
           if CheckBoxFullDebug.checked then
             Begin
              Debug_Logging('WaitingFor_PalletIDPrintToDrop is CLEARED',ClWindow);
              Debug_Logging('',ClWindow);
             End;
         end;
      end;
    end
    else
  //==========================================================================
  //================= MAIN PALLET A5 LABEL (4 SIDES) =========================
  //==========================================================================
  //==========================================================================
   if (NodeName = K_DB4125_Pallet_label_Print_label)   then // main A5 Pallet Label Request
    begin
      if ((Value = 'TRUE') and (WaitingFor_A5PalletPrintToDrop = False))  then
      begin // All clear and ready to Print A5 label
        Print_A5_Pallet_Label_DB4125 ; // Print Pallet A5 labels
        WaitingFor_A5PalletPrintToDrop := True;
        Label_Main_Pallet.Color        := ClLime;
        Label_Standby_Printer.Color    := ClLime;
        if CheckBoxFullDebug.checked then
            Debug_Logging('WaitingFor_A5PalletPrintToDrop is Set',ClWindow);
      end
     else
      begin
        if ((Value = 'FALSE') AND ( WaitingFor_A5PalletPrintToDrop = true)) then
         begin
          WaitingFor_A5PalletPrintToDrop := False;
          Label_Main_Pallet.Color        := ClYellow;
          Label_Standby_Printer.Color    := ClYellow;
          if CheckBoxFullDebug.checked then
           Begin
             Debug_Logging('WaitingFor_A5PalletPrintToDrop is CLEARED',ClWindow);
             Debug_Logging('',ClWindow);
           End;
         end;
      end;
    end
  //==========================================================================
  //================= MASTER ROLL DATA REQUESTER     =========================
  //==========================================================================
  //==========================================================================
   else
     if (NodeName = K_DB4123_MasterRoll_Pallet_Lookup)  then // Master Roll Information Request
      begin
        if ( (Value = 'TRUE') and (WaitingFor_MasterRollPalletSentToDrop = False ))  then
          Handle_MasterRoll_Event_DB4123 // fetch Masterroll data and TX
        else
         if ( (Value = 'FALSE') and (WaitingFor_MasterRollPalletSentToDrop = true ))  then // Plc drop request
          Begin
           WriteNodeValue( K_DB4123_MasterRoll_Number_Good          , 'False'); // Reset Number Good flag
           WriteNodeValue( K_DB4123_MasterRoll_typ_of_pallet        , '0');
           WriteNodeValue( K_DB4123_Masterroll_Label_Side1          , 'False');
           WriteNodeValue( K_DB4123_Masterroll_Label_orientation_1  , 'False');
           WriteNodeValue( K_DB4123_Masterroll_Label_Side2          , 'False');
           WriteNodeValue( K_DB4123_Masterroll_Label_orientation_2  , 'False');
           WriteNodeValue( K_DB4123_Masterroll_Label_Side3          , 'False');
           WriteNodeValue( K_DB4123_Masterroll_Label_orientation_3  , 'False');
           WriteNodeValue( K_DB4123_Masterroll_Label_Side4          , 'False');
           WriteNodeValue( K_DB4123_Masterroll_Label_orientation_4  , 'False');
           WriteNodeValue( K_DB4123_MasterRoll_Wrapping_program     , '0');  // New Nov 2021
           WriteNodeValue( K_DB4123_MasterRoll_Done                 , 'False');
           WriteNodeValue( K_DB4123_MasterRoll_Error                , 'False');
           WaitingFor_MasterRollPalletSentToDrop                 := False;
           if CheckBoxFullDebug.checked then
             begin
               Debug_Logging('WaitingFor_MasterRollPalletSentToDrop is CLEARED, All sent data now zeroed',ClWindow);
               Debug_Logging('',ClWindow);
             end;

          End;
      end

    // We have got an update from a listened node, but not processed it.
  else
    if (NodeName = K_DB4130_Heartbeat_Sys_Time_To_MIS ) then // Heartbeat Clock update
       begin
        iHB := Read_Int_Value(K_DB4130_Heartbeat_Sys_Time_To_MIS);
        VrLabelHeartBeat.Caption := iHB.ToString;
        WriteNodeValue( K_DB4130_Heartbeat_Sys_Time_From_MIS , iHB.ToString); // Send same value back to Koch
       end
  else
  begin
    if (K_LOGGING) Then
      Debug_Logging('Unhandled Node - (' + NodeName + ') | (This Shouldnt''t happen',ClWindow);
  end;

end;
//=================================================================================
//===========================END OF MAIN EVENT HANDLER=============================
//=================================================================================
//=================================================================================

procedure TFormMain_Koch.ProcessKochError;
Var
 Errorcode        :Variant;
 ikochErrorCode   :Integer;
begin
  //We now have the current error code.

  ErrorCode      := ReadNodeValue(K_DB4100_Main_Error_Code);
  ikochErrorCode := Errorcode;


  if ikochErrorCode > 0 then
   begin
      Case ikochErrorCode of
        0:Debug_Logging('Koch Error: 0 ,No Error (Probably A Reset).',clWebSalmon);
        1:Debug_Logging('Koch Error: 1 ,No Job Capacity, All Pallet Spaces Occupied.',clWebSalmon);
        2:Debug_Logging('Koch Error: 2 ,Rolls Per Layer Faulty.',clWebSalmon);
        3:Debug_Logging('Koch Error: 3 ,Layer Per Pallet Faulty.',clWebSalmon);
        4:Debug_Logging('Koch Error: 4 ,Pallet Type Faulty.',clWebSalmon);
        5:Debug_Logging('Koch Error: 5 ,Pattern Faulty.',clWebSalmon);
        6:Debug_Logging('Koch Error: 6 ,Pattern Could Not be Calculated',clWebSalmon);
      Else // Case
          Debug_Logging('Koch Error set error Unknown Value! ['+ikochErrorCode.ToString +']',clWebSalmon);
      end;

      if ikochErrorCode <> 0 then
      begin         //We Have Read The Error So now We Need To Reset it (I Dont Know If This is Correct)
        WriteNodeValue( K_DB4100_Main_data_send , 'False'); //Transmit block updated Flag to koch
      end;
   end;
end;

procedure TFormMain_Koch.RequestDataOrderStartDB4100();
Var

 izword         : Integer; // Vars sent from Koch on initial first contact
 izm            : Integer;
 izclock        : Integer;

 OrderStructure : TOrderInfo ;
 iFetchResult   : Integer;

begin
  //We now have the current error code.
   izword  := Read_Int_Value(K_DB4100_Main_Worksorder_No);
   izm     := Read_Int_Value(K_DB4100_Main_Machine_No);    // NOT required here but supplied by Koch
   izclock := Read_Int_Value(K_DB4100_Main_Employee_No);  /// Employee not used here but given from Koch

 // Fetch Works order info from DB and retruen to Koch, Go validate Job and machine are valid
   iFetchResult :=  FetchWorksOrderData(izword,izclock, OrderStructure) ;
  // Always send results, if good then Data, else all zeros.
  // If The job Final State <>
   if ( OrderStructure.Final_ZPSTATE <> KP_SLITTING{Because I am Always a Slitter !!} ) then
     Begin
       OrderStructure.Label_Side_1       := True;  // Only Use Siva Pallet label on side 1 for WIP EG Not Slitting
       OrderStructure.LabelOrientation_1 := False;
       OrderStructure.Label_Side_2       := False; // No other labels for WIP
       OrderStructure.LabelOrientation_2 := False;
       OrderStructure.Label_Side_3       := False;
       OrderStructure.LabelOrientation_3 := False;
       OrderStructure.Label_Side_4       := False;
       OrderStructure.LabelOrientation_4 := False;
     End;

   WriteNodeValue( K_DB4102_Job_data_Rolls_per_Layer       ,OrderStructure.RollsPerLayer.ToString);
   WriteNodeValue( K_DB4102_Job_data_Layers_Per_Pallet     ,OrderStructure.Layersperpallet.ToString);
   WriteNodeValue( K_DB4102_Job_data_Type_Of_Pallet        ,OrderStructure.Slt_zplt.ToString);
   WriteNodeValue( K_DB4102_Job_data_Pattern               ,OrderStructure.PackingPattern.ToString);
   WriteNodeValue( K_DB4102_Job_data_Cutting_width         ,OrderStructure.Width.ToString);
   WriteNodeValue( K_DB4102_Job_data_Diameter              ,OrderStructure.Diameter.ToString);
   WriteNodeValue( K_DB4102_Job_data_Wrapping_program      ,OrderStructure.Wrapping_Program.ToString);   // <<<  NEW NOV 2021
   WriteNodeValue( K_DB4102_Job_data_Strapping_program     ,OrderStructure.Strapping_program.ToString);  // <<<  NEW NOV 2021
   WriteNodeValue( K_DB4102_Job_data_packaging             ,OrderStructure.Packaging = true);
   WriteNodeValue( K_DB4102_Job_data_Label_Side1           ,OrderStructure.Label_Side_1 = True);
   WriteNodeValue( K_DB4102_Job_data_Label_orientation_1   ,OrderStructure.LabelOrientation_1 = True);
   WriteNodeValue( K_DB4102_Job_data_Label_Side2           ,OrderStructure.Label_Side_2 = True);
   WriteNodeValue( K_DB4102_Job_data_Label_orientation_2   ,OrderStructure.LabelOrientation_2 = True);
   WriteNodeValue( K_DB4102_Job_data_Label_Side3           ,OrderStructure.Label_Side_3 = True);
   WriteNodeValue( K_DB4102_Job_data_Label_orientation_3   ,OrderStructure.LabelOrientation_3 = True);
   WriteNodeValue( K_DB4102_Job_data_Label_Side4           ,OrderStructure.Label_Side_4 = True);
   WriteNodeValue( K_DB4102_Job_data_Label_orientation_4   ,OrderStructure.LabelOrientation_4 = True);


  // now send pass or fail flags
   if (iFetchResult > 0) then
    Begin
      WriteNodeValue( K_DB4100_Main_SIVA_MIS_status ,iFetchResult.toString); // Send Error number to koch
      WriteNodeValue( K_DB4100_Main_data_send   , 'True'); //Transmit block updated Flag to koch.. Even though it crashed out
      Debug_Logging('FAILURE in "RequestDataOrderStartDB4100" :No Data returned for Worksorder ' + izword.tostring,clWebSalmon);
    End
   else
    Begin   // All Good give Koch the good data for the worksorder selected in DB4102
         WriteNodeValue( K_DB4100_Main_SIVA_MIS_status           ,iFetchResult.toString); // If > 0 Bad data
         WriteNodeValue( K_DB4100_Main_data_send                 ,'True'); //Transmit block updated Flag to koch
         Debug_Logging('SUCCESS DB4100 Data returned for Worksorder '+izword.tostring,clLime);
    End;

    if CheckBoxFullDebug.checked then
     Begin
        Debug_Logging('K_DB4102_Job_data_Rolls_per_Layer       '+ OrderStructure.RollsPerLayer.ToString,clWindow);
        Debug_Logging('K_DB4102_Job_data_Layers_Per_Pallet     '+ OrderStructure.Layersperpallet.ToString,clWindow);
        Debug_Logging('K_DB4102_Job_data_Type_Of_Pallet        '+ OrderStructure.Slt_zplt.ToString,clWindow);
        Debug_Logging('K_DB4102_Job_data_Pattern               '+ OrderStructure.PackingPattern.ToString,clWindow);
        Debug_Logging('K_DB4102_Job_data_Cutting_width         '+ OrderStructure.Width.ToString,clWindow);
        Debug_Logging('K_DB4102_Job_data_Diameter              '+ OrderStructure.Diameter.ToString,clWindow);
        Debug_Logging('K_DB4102_Job_data_Wrapping_program      '+ OrderStructure.Wrapping_Program.ToString,clWindow);   // << NEW NOV 2021
        Debug_Logging('K_DB4102_Job_data_Strapping_program     '+ OrderStructure.Strapping_program.ToString,clWindow);   // << NEW NOV 2021
        Debug_Logging('K_DB4102_Job_data_packaging             '+ BoolToStr(OrderStructure.Packaging,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_Side1           '+ BoolToStr(OrderStructure.Label_Side_1,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_orientation_1   '+ BoolToStr(OrderStructure.LabelOrientation_1,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_Side2           '+ BoolToStr(OrderStructure.Label_Side_2,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_orientation_2   '+ BoolToStr(OrderStructure.LabelOrientation_2,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_Side3           '+ BoolToStr(OrderStructure.Label_Side_3,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_orientation_3   '+ BoolToStr(OrderStructure.LabelOrientation_3,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_Side4           '+ BoolToStr(OrderStructure.Label_Side_4,true),clWindow);
        Debug_Logging('K_DB4102_Job_data_Label_orientation_4   '+ BoolToStr(OrderStructure.LabelOrientation_4,true),clWindow);
        Debug_Logging('K_DB4100_Main_SIVA_MIS_status           '+ iFetchResult.toString,clWindow) ; // If 0 = Bad data+ 1 = Data Good
        Debug_Logging('K_DB4100_Main_data_send                 True',clWindow); //Transmit block updated Flag to koch
     End;
End;


Function TFormMain_Koch.Koch_Pallet_Translate(zplt_in:integer):Integer;
 begin
    if CheckBoxFullDebug.checked then
      Debug_Logging('Converting zplt_in ' +zplt_in.ToString ,clWebOrange);

    Result := Koch_Pallet_Translator(DMSIVADATA.UniConnectionMain, UniTransactionKochMain ,zplt_in);

    if CheckBoxFullDebug.checked then
      Debug_Logging('Converted to zplt_in ' + result.ToString ,clWebOrange);

 end;

Function TFormMain_Koch.FetchWorksOrderData(const izword         : integer;
                                            const izclock        : Integer; {-1 = Dont check / return}
                                            var   OrderStructure : TOrderInfo ):Integer; // 0=Good, >0 = Error Number
var
  rv           : Double;
//  PrintedSides : Integer;
begin
 try
 (*
 //  FetchWorksOrderData := 0;   // Success , all good to proceed
//  FetchWorksOrderData := 1;   // failed , Unknown Worksorder
//  FetchWorksOrderData := 2;   // failed , Unknown Wrapping configuration
//  FetchWorksOrderData := 3;   // failed , Invalid Pallet in spec
//  FetchWorksOrderData := 4;   // failed , Invalid Employee Clock number
//  FetchWorksOrderData := 100; // failed , Spec is on Stop !!!
//  FetchWorksOrderData := 200; // failed , Ord/Spec/Cust is on Stop !!!
   Fill the OrderStructure with all the available wrapping and slitter banding program numbers
*)

  FetchWorksOrderData := 0; // Success.. Default

  UniQuerySQL.close;
  UniQuerySQL.sql.clear;
  UniQuerySQL.SQL.add('Select W.zword, w.zmslit,s.zpstate, s.zslwidth, s.zsllen, s.zslslit');
  UniQuerySQL.SQL.add(',s.zswrap,s.zlockstat, o.zlockstat as OrdzLockstat');
  UniQuerySQL.SQL.add(',s.zslrplay, s.zsllayplt, s.zlaypats, s.ZextPW, s.zsltpw, s.zsltbn');
  UniQuerySQL.SQL.add(',c.zcplt, c.zcplt2, c.zcplt3, c.zcplt4, c.zcplt1p, c.zcplt2p, c.zcplt3p ,c.zcplt4p');
  UniQuerySQL.SQL.add(',l.zkptype, l.zkeasyl, l.zkprpl');
  UniQuerySQL.SQL.add(',(Select zemp from employee where zclock = ' + izclock.tostring+') as zemp');
  UniQuerySQL.SQL.add(',p.zprnpw, la.zlampw , f.zffspw, v.zcnvPW ');
  UniQuerySQL.SQL.add(',s.zplt,p.zpplt,la.zlplt, s.zslplt,f.zfplt,v.zplt as zcnvplt');
  UniQuerySQL.SQL.add('FROM      worksord w');
  UniQuerySQL.SQL.add('     join ord2wks  o2w on o2w.zword = w.zword');
  UniQuerySQL.SQL.add('     join acord    o   on o.zord = o2w.zord  and o.zcst = o2w.zcst');
  UniQuerySQL.SQL.add('     join acspec   s   on s.zspec = w.zspec');
  UniQuerySQL.SQL.add('     join accst    c   on c.zcst = o.zcst');
  UniQuerySQL.SQL.add('     join layoutr  l   on l.zlaypat = s.zlaypats');
  UniQuerySQL.SQL.add('LEFT join acsprint p   on p.zspec = s.zspec ');
  UniQuerySQL.SQL.add('LEFT join laminate la  on la.zspec = s.zspec ');
  UniQuerySQL.SQL.add('LEFT join FFSspec  f   on f.zspec = s.zspec ');
  UniQuerySQL.SQL.add('LEFT join acsconv  v   on v.zspec = s.zspec ');
  UniQuerySQL.SQL.add('where w.zword = ' + iZword.Tostring );
  UniQuerySQL.open;

//  if CheckBoxFullDebug.checked then
//   MemoSQL.lines.AddStrings(UniQuerySQL.SQL);

  if ((UniQuerySQL.IsEmpty) OR                                      // Worksorder found ...?
        (UniQuerySQL.FieldByname('zlockstat').AsInteger > 0) OR     // Spec Locked ....?
        (UniQuerySQL.FieldByname('Ordzlockstat').AsInteger > 0) OR  // Job/Customer Locked ...?
        ((UniQuerySQL.FieldByname('zemp').IsNull) AND (izclock <> -1 ) ) // Good Employee if Given ???
        ) then
   begin
    OrderStructure.RollsPerLayer      := 0;
    OrderStructure.Layersperpallet    := 0;
    OrderStructure.Ext_zplt           := 0;  //  1 = EURO , 2 = CHEP
    OrderStructure.Prn_zplt           := 0;
    OrderStructure.Lam_zplt           := 0;
    OrderStructure.Slt_zplt           := 0;
    OrderStructure.ffs_zplt           := 0;
    OrderStructure.cnv_zplt           := 0;
    OrderStructure.ngr_zplt           := 0;



    // Easy Reel Loader Pattern number, if we set this to 0 then roll ejected
    // immediatly after being slit, Matthias 30 Sep 2021 09:15
    // this is so layflat rolls can be slit then ejected manually.

    OrderStructure.PackingPattern     := 0;
    OrderStructure.Width              := 0;
    OrderStructure.Diameter           := 0;
    OrderStructure.Packaging          := False;

    OrderStructure.Label_Side_1       := False;
    OrderStructure.LabelOrientation_1 := False;
    OrderStructure.Label_Side_2       := False;
    OrderStructure.LabelOrientation_2 := False;
    OrderStructure.Label_Side_3       := False;
    OrderStructure.LabelOrientation_3 := False;
    OrderStructure.Label_Side_4       := False;
    OrderStructure.LabelOrientation_4 := False;
    OrderStructure.Final_ZPSTATE      := 0;
    OrderStructure.Wrapping_Program   := 0;  // Cling Film Pall;et wrapping
    OrderStructure.Strapping_program  := 0;  // Pallet Roll Banding

    OrderStructure.Ext_zplt           := 0;  // These have to be converted into Chris Goodall's CHEP or EURO pallet types before send to Koch
    OrderStructure.Prn_zplt           := 0;
    OrderStructure.Lam_zplt           := 0;
    OrderStructure.Slt_zplt           := 0;
    OrderStructure.ffs_zplt           := 0;
    OrderStructure.cnv_zplt           := 0;
    OrderStructure.ngr_zplt           := 0;


    if (UniQuerySQL.IsEmpty) then
      FetchWorksOrderData := 1 // 1 = No valid Worksorder found for the Requested zword
    Else
     if ( (UniQuerySQL.FieldByname('zemp').IsNull) AND (izclock <> -1 ) ) then
        FetchWorksOrderData := 4 // Illegal zclock number supplied by Koch/Kamph
      Else
        if UniQuerySQL.FieldByname('zlockstat').AsInteger > 0 then
          FetchWorksOrderData := 100  // All Stop Job is not to be made !! SPEC is LOCKED
        Else
         if UniQuerySQL.FieldByname('Ordzlockstat').AsInteger > 0 then
           FetchWorksOrderData := 200  // All Stop Job/Order/Customer is locked ALL STOP
         Else
           FetchWorksOrderData := 1000; // Unkown Error
    Exit; // Failed......Jump out
   end
  Else
   begin  // All Good with data from Koch lets return his data....
    if CheckBoxFullDebug.checked then
     MemoJobs.lines.add( FormatDateTime('dd mmm hh:nn:ss',now) + '  : Job Located and assembling results for word '+iZword.tostring);

    OrderStructure.RollsPerLayer    := UniQuerySQL.FieldByname('zslrplay').AsInteger;  // Rolls per layer
    OrderStructure.Layersperpallet  := UniQuerySQL.FieldByname('zsllayplt').AsInteger; // Layers per pallet
    // Now translate all the different zplt codes into the Koch
    OrderStructure.Ext_zplt         := Koch_Pallet_Translate(UniQuerySQL.FieldByname('zplt').AsInteger);
    OrderStructure.Prn_zplt         := Koch_Pallet_Translate(UniQuerySQL.FieldByname('zpplt').AsInteger);
    OrderStructure.Lam_zplt         := Koch_Pallet_Translate(UniQuerySQL.FieldByname('zlplt').AsInteger);
    OrderStructure.Slt_zplt         := Koch_Pallet_Translate(UniQuerySQL.FieldByname('zslplt').AsInteger);
    OrderStructure.ffs_zplt         := Koch_Pallet_Translate(UniQuerySQL.FieldByname('zfplt').AsInteger);
    OrderStructure.cnv_zplt         := Koch_Pallet_Translate(UniQuerySQL.FieldByname('zcnvplt').AsInteger);
    OrderStructure.NGR_zplt         := 1; // default to EURO ????

    OrderStructure.Final_ZPSTATE      := UniQuerySQL.FieldByname('zpstate').AsInteger; // Final Pallet State

    // Load Easy Reel loader pattern from LAYOUTR table linked to slitting ZLAYPATS
    OrderStructure.PackingPattern   := UniQuerySQL.FieldByname('zkeasyl').AsInteger; // Easyloader Index

    rv                      := UniQuerySQL.FieldByname('zslwidth').AsFloat;
    OrderStructure.Width    := System.Math.Floor(rv);

    // We cant guarantee the actual diam so give then 0...Always
    rv := 0.0; // <<<<< TEMP FIX
    OrderStructure.Diameter         := System.Math.Floor(rv);
//      ZWRAP	ZWRAPDESC	ZWRAPINT
//      0	"STANDARD WRAP"	"F"
//      1	"WRAP EVERY ROLL"	"F"
//      2	"FCP - WRAP EVERY ROLL"	"F"
//      3	"FOLLOW CUSTOMER SPECIFIC PACKING REQUIREMENTS"	"F"

    if UniQuerySQL.FieldByname('zswrap').AsInteger = 0 then   // ***** INDIVIDUAL ROLL WRAPPING AT SLITTING ONLY  *****
      OrderStructure.Packaging        := False // Packaging of each roll = NO !!
    else
      OrderStructure.Packaging        := True; // Packaging of each roll = YES !!


    OrderStructure.Ext_Wrap_program  := UniQuerySQL.FieldByname('zextpw').AsInteger;  // Save All Cling Film Wrapping fro Ext,prn,slt,lam,ffs,cnv.
    OrderStructure.Prn_Wrap_program  := UniQuerySQL.FieldByname('zprnpw').AsInteger;
    OrderStructure.Wrapping_Program  := UniQuerySQL.FieldByname('zsltpw').AsInteger;
    OrderStructure.Lam_Wrap_program  := UniQuerySQL.FieldByname('zlampw').AsInteger;
    OrderStructure.FFS_Wrap_program  := UniQuerySQL.FieldByname('zffspw').AsInteger;
    OrderStructure.Cnv_Wrap_Program  := UniQuerySQL.FieldByname('zcnvpw').AsInteger;
    OrderStructure.NGR_Wrap_Program  := 1; // Default to always default Wrap prog 1

    OrderStructure.Strapping_program := UniQuerySQL.FieldByname('zsltbn').AsInteger; //  Banding / Strapping for slitting ONLY !!!

    OrderStructure.LabelOrientation_1 := UniQuerySQL.FieldByname('zcplt1p').AsBoolean;  // Use Side 1 Portrait mode to indicate Portrait
    OrderStructure.LabelOrientation_2 := UniQuerySQL.FieldByname('zcplt2p').AsBoolean;  // Use Side 2 Portrait mode to indicate Portrait
    OrderStructure.LabelOrientation_3 := UniQuerySQL.FieldByname('zcplt3p').AsBoolean;  // Use Side 3 Portrait mode to indicate Portrait
    OrderStructure.LabelOrientation_4 := UniQuerySQL.FieldByname('zcplt4p').AsBoolean;  // Use Side 4 Portrait mode to indicate Portrait


    (* CALCULATE Number of sides to print: The Koch system "DEMANDS" that we print all previous sides
      Upto the side we require so the only valid printed sides are:
          1
          1 & 2
          1 & 2 & 3
          1 & 2 & 3 & 4   No other sequences are allowed eg 1 & 3

      Another issue is the following statement by Adrian "15th Sep 2021" that
        EVERY side 1 WILL BE only be Standard Siva pallet labels
        All Side 2 must be Pallet summary sheet if selected in the Customer table or Custom pallet label
        So if a pallet has been set as selected in the 2nd pallet in the customer table
        and the print pallet summary sheet checked as well then the second side will be
        a pallet summary sheet and the custom sheet will be ignored.
        So if a custom pallet label is requested it can be placed only on sides 2,3,4, but if
        a pallet summary sheet is required then only side 3,4 are available for the custom label. *)

    OrderStructure.Label_Side_1 :=  UniQuerySQL.FieldByname('zcplt').AsInteger  > 0 ;
    OrderStructure.Label_Side_2 :=  UniQuerySQL.FieldByname('zcplt2').AsInteger > 0 ;
    OrderStructure.Label_Side_3 :=  UniQuerySQL.FieldByname('zcplt3').AsInteger > 0 ;
    OrderStructure.Label_Side_4 :=  UniQuerySQL.FieldByname('zcplt4').AsInteger > 0 ;

    if (OrderStructure.Label_Side_1 = False ) And (OrderStructure.Label_Side_2 = False ) And
       (OrderStructure.Label_Side_3 = False ) And (OrderStructure.Label_Side_4 = False ) Then
      OrderStructure.Label_Side_1 := True ; // Always print a label on side 1

    FetchWorksOrderData := 0; // Data is Good
   end;

  UniQuerySQL.Close;
 except
   on e:exception do
    begin
      Debug_Logging( 'Fail in: FetchWorksOrderData : UniQuerySQL.SQL : '+UniQuerySQL.SQL.text +' : ' + e.Message ,clRed );
    end;
 end;
end;

procedure TFormMain_Koch.FormShow(Sender: TObject);
begin
   if KillSystem = true then
      Close;
end;

procedure TFormMain_Koch.AdvGlowButton2Click(Sender: TObject);
begin
  StartSystem;

  Timer_Watchdog.Enabled := ( AdvSmoothSliderTimer.State = ssOn) ; // Added 5th Feb 2022

end;


procedure TFormMain_Koch.AdvGlowButton3Click(Sender: TObject);
begin
      if not OpenOPCcomms then
       Begin
         Showmessage('Failed to Connect to Koch PLC');
         Exit;
       End;
end;

procedure TFormMain_Koch.AdvGlowButton_MANUAL_READClick(Sender: TObject);
var
  sValue: String;
begin
  if AdvGridDropDownReadNames.ItemIndex >=0 then
   begin
      sValue := ReadNodeValue(AdvGridDropDownReadNames.Items[AdvGridDropDownReadNames.Itemindex].Text[1]);
      Debug_Logging( AdvGridDropDownReadNames.Items[AdvGridDropDownReadNames.Itemindex].Text[1] +' : ' + sValue,clWindow  );
   end
  Else
   Showmessage('Nothing to do..... ');

end;

procedure TFormMain_Koch.AdvGlowButton_MANUAL_SENDClick(Sender: TObject);
var
  ov    : OleVariant;
  Node  : string;
begin
 if EditTXValue.text <> '' then
  Begin
  if AdvGridDropDownWriteNames.ItemIndex >= 0 then
   begin  // procedure TFormMain_Koch.WriteNodeValue(Node: String; WriteValue: OleVariant);
    ov   := EditTXValue.text;
    Node := AdvGridDropDownWriteNames.Items[AdvGridDropDownWriteNames.Itemindex].Text[1] ;
    WriteNodeValue(Node ,ov);
   end
  Else
   Showmessage('Nothing to do..... ');

  End;
end;



procedure TFormMain_Koch.AdvGlowButton5Click(Sender: TObject);
begin
  Delete_A_Roll;
end;

procedure TFormMain_Koch.AdvGlowButtonClearLogClick(Sender: TObject);
begin
  Memo_Debug.Clear;
  MemoJOBS.lines.Clear;
  Debug_Logging('Debug Log: ',clWindow);
end;

procedure TFormMain_Koch.Debug_Logging(sMessage: String ; lineColour:TColor);
var
 FileName : string;
 DebugFile   : TextFile;

begin
  // Try to open a text file for writing to
   { to get uses document pathSystem.IOUtils in your uses then use TPath.GetDocumentsPath}
  fileName := TPath.GetDocumentsPath +'\KochDebug'+FormatDateTime('ddmmyyyy',now)+'.txt';
  if fileexists(fileName) then
    begin
      AssignFile(DebugFile, fileName);
      Append(DebugFile);  // Append to log file
    end
  Else
    begin
      AssignFile(DebugFile, fileName);
      ReWrite(DebugFile);   //  MAKE NEW FILE
    end;

  // Write to the file
  Writeln(DebugFile,FormatDateTime('dd mmm hh:nn:ss',now) +': '+ sMessage);
  Memo_debug.lines.add(FormatDateTime('dd mmm hh:nn:ss',now) +': '+ sMessage);
  // Close the file
  CloseFile(DebugFile);


//  AdvRichEditor_Debug.BeginUpdate;
//  if sMessage <> '' then
//    tte := AdvRichEditor_Debug.AddText(FormatDateTime('dd mmm hh:nn:ss',now) +': '+ sMessage,ClBlack{Font},LineColour);
//  AdvRichEditor_Debug.AddLineBreak;
//  AdvRichEditor_Debug.GotoTextEnd;
//  AdvRichEditor_Debug.EndUpdate;





end;

procedure TFormMain_Koch.Delete_A_Roll;
var
   qvPallet, qvRoll           : TAdvMultiInputQueryValue;
   vTargetPallet, vTargetRoll : String;
   UniQueryDelete             : TUniQuery;
   UniTRansactionDelete       : TUniTransaction;

Begin

  AdvMultiInputQueryDialogDelete.QueryValues.Clear;
  AdvMultiInputQueryDialogDelete.Caption := ' WARNING THIS CAN''T BE UNDONE !!!';


  AdvMultiInputQueryDialogDelete.LabelWidth := 150;
  qvPallet        := AdvMultiInputQueryDialogDelete.QueryValues.Add;
  qvPallet.&Label := 'Pallet # ?';
  qvPallet.Name   := 'PalletNo';
  AdvMultiInputQueryDialogDelete.Values['PalletNo'].DefaultValue  := '0'; // No Pallet ....

  qvRoll        := AdvMultiInputQueryDialogDelete.QueryValues.Add;
  qvRoll.&Label := 'Roll to DELETE # ?';
  qvRoll.Name   := 'TargetRoll';
  AdvMultiInputQueryDialogDelete.Values['TargetRoll'].DefaultValue := '0';

  if AdvMultiInputQueryDialogDelete.Execute(True) <> MrOk then
   Exit ;

  vTargetPallet := AdvMultiInputQueryDialogDelete.Values['PalletNo'].ResultValue;
  vTargetRoll   := AdvMultiInputQueryDialogDelete.Values['TargetRoll'].ResultValue;



 try
   Try
    UniTRansactionDelete := TUniTransaction.create(nil);
    UniTRansactionDelete.DefaultConnection := DMSIVADATA.UniConnectionMain;

    UniQueryDelete := TUniQuery.Create(nil);
    UniQueryDelete.Transaction := UniTRansactionDelete;
    UniQueryDelete.Connection  := DMSIVADATA.UniConnectionMain;
    UniTRansactionDelete.StartTransAction;

    UniQueryDelete.Close;
    UniQueryDelete.sql.clear;
    UniQueryDelete.SQL.Add('  Select zpallet,zpitm from papitm i ');
    UniQueryDelete.SQL.Add('  where i.zpitm = ' + vTargetRoll);
    UniQueryDelete.SQL.Add('  and i.zpallet = ' + vTargetPallet);
    UniQueryDelete.open;

    if UniQueryDelete.isEmpty  then
     begin
      Showmessage('Unable to validate pallet ['+vTargetPallet+'] or Roll ['+vTargetRoll+']' );
      exit;
     end;

    // Ok we are going for the kill.....
    UniQueryDelete.Close;
    UniQueryDelete.sql.clear;
    UniQueryDelete.SQL.Add('  Delete from papitm i ');
    UniQueryDelete.SQL.Add('  where i.zpitm = ' + vTargetRoll);
    UniQueryDelete.SQL.Add('  and i.zpallet = ' + vTargetPallet);
    UniQueryDelete.ExecSQL;

    if UniQueryDelete.Transaction.active then
      UniQueryDelete.Transaction.commit;

    Showmessage('Pallet ' + vTargetPallet + ' Roll # ' + vTargetRoll +' Deleted and committed ');

   Finally
       FreeandNil(UniQueryDelete);
       FreeandNil(UniTRansactionDelete);
   End;

 Except
  On E:Exception Do
   Begin
    Showmessage('Error Deleting roll from pallet. SQL : '+UniQueryDelete.SQL.text + ' : ' + e.Message );
   End;

 end;



End;

procedure TFormMain_Koch.AdvGlowButtonLicenceClick(Sender: TObject);
var
  SerialNumber: Int64;
begin
  // Instantiate the client object
  // Obtain the serial number from the license info.
  SerialNumber := Int64(client.LicenseInfo['Multipurpose.SerialNumber']);

  // Display the serial number.
  MemoJobs.lines.add('SerialNumber: ' + SerialNumber.ToString);

  // Determine whether we are running as demo or trial.
  if ((1111110000 <= SerialNumber) and (SerialNumber <= 1111119999)) then
    MemoJobs.lines.add('Demo or trial license.')
  else
    MemoJobs.lines.add('Active license.');
end;

//======================================================================
//======================================================================
//======================================================================

procedure TFormMain_Koch.AdvGlowButtonInnerRollClick(Sender: TObject);
begin
     // Send Test label to Pallet CORE roll Printer 4"x3"
   SendTestpageTo_SmallPrinter(KochItemPrinterName);
end;

procedure TFormMain_Koch.AdvGlowButtonOuterRollClick(Sender: TObject);
begin
     // Send Test label to External Roll Printer  4"x3"
  SendTestpageTo_SmallPrinter(KochExtRollPrinterName);
end;

procedure TFormMain_Koch.AdvGlowButtonPalletIDClick(Sender: TObject);
begin
      // Send Test label to Pallet Id Printer 4"x3"
   SendTestpageTo_SmallPrinter(KochPalletIDPrinterName);
end;

procedure TFormMain_Koch.AdvGlowButtonPalletMainClick(Sender: TObject);
// var
//  izpallet :integer;
//  iPrintSide :Integer;
//  iError :Integer;
begin
   // Send test printout to Main Printer A5
  SendTestpageTo_A5(KochPalletA5MainPrinterName);

//  izpallet    := 1783961;
//  iPrintSide  := 1;
//  Print_A5_Label_DB4125(iZPallet,iPrintSide, KochPalletA5MainPrinterName, iError );    /// Blocking Risk Here ???

end;

procedure TFormMain_Koch.AdvGlowButtonSetFontClick(Sender: TObject);
begin
 if FontDialog1.Execute then
  Begin
   Memo_Debug.font.Name := FontDialog1.Font.Name;
   Memo_Debug.font.Size := FontDialog1.Font.Size;

  //   DebugLog.Font := FontDialog1.Font;
  //   AdvRichEditor_Debug.SelectAll;
  //   AdvRichEditor_Debug.SetSelectionFontName(FontDialog1.Font.Name);
  //   AdvRichEditor_Debug.SetSelectionFontSize(FontDialog1.Font.Size);

  End;
end;

procedure TFormMain_Koch.AdvGlowButtonStandByClick(Sender: TObject);
begin
  // Send test printout to Backup Printer A5
  SendTestpageTo_A5(KochPalletA5StandByPrinterName);
end;

//======================================================================
//======================================================================
//======================================================================

procedure TFormMain_Koch.AdvGlowButtonPrinterSetupClick(Sender: TObject);
begin
  RUN_WeighAdmin;
end;



procedure TFormMain_Koch.RUN_WeighAdmin;
var
 waf :TFormWeighAdmin;
begin
 Try
   waf:=TFormWeighAdmin.Create(Self);
   waf.Showmodal;
 Finally
   waf.free;
  End;
end;


procedure TFormMain_Koch.AdvGlowButton_CANCELClick(Sender: TObject);
begin
  Timer_Watchdog.Enabled := False;
  SivaData.DMSIVADATA.DisconnectDataBase;  // True = ok
  close;
end;

procedure TFormMain_Koch.AdvSmoothSliderTimerStateChanged(Sender: TObject;
  State: TAdvSmoothSliderState; Value: Double);
begin
   Timer_Watchdog.Enabled := ( AdvSmoothSliderTimer.state = ssOn) ;
end;


procedure TFormMain_Koch.FetchorderDataFromKochInfo;
var
  EmployeeNo,
  WorksOrdNo,
  MachineNo              : Integer;
  bFailedJob             : Boolean;
  OrderStructure         : TOrderInfo;
  iFetchStatus           : Integer;

Begin
  bFailedJob := False;
  //We first Need To Fetch All The Required Information SLITTING ONLY !!! so Wrapping and Banding As Well
  //Read Employee    .... Not used , We need it when the roll / Pallet is Created Only !!!!
  EmployeeNo := ReadNodeValue('"DB4123_Order_Data"."Employee No"');

  //Read WorksOrdNo
  WorksOrdNo := ReadNodeValue('"DB4123_Order_Data"."Works Ord No"');

  //Read MachineNo
  MachineNo := ReadNodeValue('"DB4123_Order_Data"."Machine No"');

  MemoJobs.Lines.Add('NEW JOB: Employee = ' + inttostr(EmployeeNo) + ' | WorksOrdNo = ' + inttostr(WorksOrdNo) + ' | MachineNo = ' + inttostr(MachineNo));

  iFetchStatus := FetchWorksOrderData(WorksOrdNo, EmployeeNo, OrderStructure );

  if iFetchStatus = 0 then // 0 = good, >0 = Fail
    Begin
       WriteNodeValue(K_DB4100_Main_SIVA_MIS_status,0);
       WriteNodeValue(K_DB4100_Main_data_send,'True');
    End
  else
    Begin
  //Now we have our information from the database we need to send it back to Koch.
      WriteNodeValue(K_DB4102_Job_data_Rolls_per_Layer     ,OrderStructure.RollsPerLayer);
      WriteNodeValue(K_DB4102_Job_data_Layers_Per_Pallet   ,OrderStructure.Layersperpallet);
      WriteNodeValue(K_DB4102_Job_data_Type_Of_Pallet      ,OrderStructure.Slt_zplt);
      WriteNodeValue(K_DB4102_Job_data_Pattern             ,OrderStructure.PackingPattern);
      WriteNodeValue(K_DB4102_Job_data_Cutting_width       ,OrderStructure.Width);
      WriteNodeValue(K_DB4102_Job_data_Wrapping_program    ,OrderStructure.Wrapping_Program);   // << ***SLITTING*** New NOV 2021
      WriteNodeValue(K_DB4102_Job_data_Strapping_program   ,OrderStructure.Strapping_program); // <<  ***SLITTING*** New NOV 2021
      WriteNodeValue(K_DB4102_Job_data_packaging           ,OrderStructure.Packaging);
      WriteNodeValue(K_DB4102_Job_data_Label_Side1         ,OrderStructure.Label_Side_1);
      WriteNodeValue(K_DB4102_Job_data_Label_orientation_1 ,OrderStructure.LabelOrientation_1);
      WriteNodeValue(K_DB4102_Job_data_Label_Side2         ,OrderStructure.Label_Side_2);
      WriteNodeValue(K_DB4102_Job_data_Label_orientation_2 ,OrderStructure.LabelOrientation_2);
      WriteNodeValue(K_DB4102_Job_data_Label_Side3         ,OrderStructure.Label_Side_3);
      WriteNodeValue(K_DB4102_Job_data_Label_orientation_3 ,OrderStructure.LabelOrientation_3);
      WriteNodeValue(K_DB4102_Job_data_Label_Side4         ,OrderStructure.Label_Side_4);
      WriteNodeValue(K_DB4102_Job_data_Label_orientation_4 ,OrderStructure.LabelOrientation_4);
    End;

  if CheckBoxFullDebug.checked then
     Begin
        Debug_Logging('( K_DB4102_Job_data_Rolls_per_Layer       '+OrderStructure.RollsPerLayer.ToString,clWindow);
        Debug_Logging('( K_DB4102_Job_data_Layers_Per_Pallet     '+OrderStructure.Layersperpallet.ToString,clWindow);
        Debug_Logging('( K_DB4102_Job_data_Type_Of_Pallet        '+OrderStructure.Slt_zplt.ToString,clWindow);
        Debug_Logging('( K_DB4102_Job_data_Pattern               '+OrderStructure.PackingPattern.ToString,clWindow);
        Debug_Logging('( K_DB4102_Job_data_Cutting_width         '+OrderStructure.Width.ToString,clWindow);
        Debug_Logging('( K_DB4102_Job_data_Wrapping_Program      '+OrderStructure.Wrapping_Program.ToString,clWindow);  // <<< New Nov 2021
        Debug_Logging('( K_DB4102_Job_data_Strapping_program     '+OrderStructure.Strapping_program.ToString,clWindow);  // <<< New Nov 2021
        Debug_Logging('( K_DB4102_Job_data_Diameter              '+OrderStructure.Diameter.ToString,clWindow);
        Debug_Logging('( K_DB4102_Job_data_packaging             '+BoolToStr(OrderStructure.Packaging,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_Side1           '+BoolToStr(OrderStructure.Label_Side_1,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_orientation_1   '+BoolToStr(OrderStructure.LabelOrientation_1,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_Side2           '+BoolToStr(OrderStructure.Label_Side_2,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_orientation_2   '+BoolToStr(OrderStructure.LabelOrientation_2,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_Side3           '+BoolToStr(OrderStructure.Label_Side_3,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_orientation_3   '+BoolToStr(OrderStructure.LabelOrientation_3,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_Side4           '+BoolToStr(OrderStructure.Label_Side_4,true),clWindow);
        Debug_Logging('( K_DB4102_Job_data_Label_orientation_4   '+BoolToStr(OrderStructure.LabelOrientation_4,true),clWindow);
        Debug_Logging('( K_DB4100_Main_SIVA_MIS_status           '+iFetchStatus.toString,clWindow) ; // If 0 = Bad data+ 1 = Data Good
     End;

End;


function  TFormMain_Koch.ReadNodeValue(Node: String): OleVariant;
var
  ReadNode: String;
begin
 Try

  ReadNode := 'nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s='+Node;

  Result   := Client.ReadValue(Endpoint,ReadNode);

 Except
    //COMException            , Especially common in OPC Classic.
    //UAStatusCodeException   , When the OPC-UA status code is not as expected.
    //UAEngineException       , For errors that originats in the OPC-UA engine and not in the OPC service (or OPC-UA SDK).
    //UAServiceException      , When an OPC-UA defined error occurs.
    //LicenseException        , If there is a problem with components license in QuickOPC-UA.
  on E: Exception Do
    Begin
     Debug_Logging('Error reading value From PLC. Target ['+ReadNode +'] :' + e.ToString,clWebSalmon);
    End;
 End;
end;

procedure TFormMain_Koch.WriteNodeValue(Node: String; WriteValue: OleVariant);
var
  WriteNode: String;
begin
 try
  WriteNode := 'nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=' + Node;
  Client.WriteValue(Endpoint,WriteNode,WriteValue);
  Except
    //COMException            , Especially common in OPC Classic.
    //UAStatusCodeException   , When the OPC-UA status code is not as expected.
    //UAEngineException       , For errors that originats in the OPC-UA engine and not in the OPC service (or OPC-UA SDK).
    //UAServiceException      , When an OPC-UA defined error occurs.
    //LicenseException        , If there is a problem with components license in QuickOPC-UA.
   on E: Exception Do
    Begin
     Debug_Logging('Error writing value to PLC. Target ['+WriteNode +'] :' + e.ToString,clWebSalmon);
    End;
 End;
end;

procedure TFormMain_Koch.addListener(DataPoint: String);
var
  Node: String;
begin
 try
  if CheckBoxFullDebug.checked then
   Begin
     Debug_Logging('',cllime);
     Debug_Logging('Adding listener for : ' + DataPoint,clLime);
   End;

  Node := 'nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=' + DataPoint;

  Client.SubscribeDataChange(EndPoint
                            ,Node {Node descriptor }
                            ,1500   {1500 = 1.5s Sample Interval});

  if CheckBoxFullDebug.checked then
       Debug_Logging('Added listener for  : ' + DataPoint,clLime);

 Except
  on E:Exception do
   Debug_Logging('Failed to Add Listener for ' + DataPoint + e.Message,clWebSalmon );
 end;
end;


//Function TFormMain_Koch.Read_DateTime_Value(NodeName:String; var sHex:String):TDateTime;
//type
// TByteArray = array of Byte;
//Var
// vValue   : Variant;
// i        : Integer;
// Tba      : TByteArray;
//
//begin
//    sHex := '';
//    vValue :=  ReadNodeValue(NodeName);
//    if VarIsArray(vValue) then
//      begin
//       SetLength(Tba, VarArrayHighBound(VValue, 1) + 1);
//       for I:= 0 to High(tba) do
//         tba[I] := VValue[I];
//      end
//    else
//      begin
//        SetLength(tba, 1);
//        Tba[0] := VValue;
//        sHex := 'Not Array ';
//    end;
//  try                       {Year Base + Year} {M}     {D}     {H}     {n}     {s}
//     result := EncodeDateTime(1988 + TBA[0],   Tba[1], Tba[2], Tba[3], Tba[4], Tba[5], 000);
//     sHex:= shex + tba[0].ToHexString;        // YEAR Return Hex value of array...Debugging
//     sHex:= sHex + tba[1].ToHexString; // MONTH
//     sHex:= sHex + tba[2].ToHexString; // DAY
//     sHex:= sHex + tba[3].ToHexString; // HOUR
//     sHex:= sHex + tba[4].ToHexString; // MIN
//     sHex:= sHex + tba[5].ToHexString; // SECONDS
//  except
//   on E:Exception do
//    Begin
//      Result := Now();
//      sHex := 'Error in data decode ' + e.Message;
//      sHex := sHex + ' ' + Get
//    End;
//  end;
//
//  SetLength(Tba,0);
//
//End;



Function TFormMain_Koch.Read_Int_Value(NodeName:String):Integer;
Var
 vValue   :Variant;
 iValue   :Integer;
begin
  vValue :=  ReadNodeValue(NodeName);
  iValue :=  vValue;
  Read_Int_Value := iValue;
End;

Function TFormMain_Koch.Read_Boolean_Value(NodeName:String):Boolean;
Var
 vValue   :Variant;
 bValue   :Boolean;
begin
  vValue :=  ReadNodeValue(NodeName);
  bValue :=  vValue;
  Read_Boolean_Value := bValue;
End;


Function TFormMain_Koch.Read_Float_Value(NodeName:String):Double;
Var
 vValue   :Variant;
 rValue   :Double;
begin
  vValue :=  ReadNodeValue(NodeName);
  rValue :=  vValue;
  Read_Float_Value := rValue;
End;

procedure TFormMain_Koch.Create_Label_Core_DB4102;
var
   iAuditNO   :integer;
   AuditDate  :TdateTime;
   ZWORD      :Integer;
   rweight    :Double;
   rLength    :Double;
   zpitem     :Integer;
   zpallet    :integer;
   izclock    :Integer;
   izm        :Integer;
   ParamFailure  :Boolean;
Begin

(*  // Fetch the following
        AuditNo
        Audit TimeStamp
        Zword
        weight
        Length
        zclock <<<<<<<<<<<<  Not available Yet !!!!

        Set bIsPrintCoreLabel when printing to stop log jam at printing routine
*)
  // First Go fetch the PLC info from Rudolf...
   iAuditNo   := Read_Int_Value(K_DB4101_Core_Labeling_audit_no);
   AuditDate  := now(); // DONT use audit as weighh only gives reliable date not time !!!! Read_DateTime_Value( K_DB4101_Core_Labeling_Audit_timestamp,sHex); {sHex is used to get hex of date array for debug}
   zword      := Read_Int_Value(K_DB4101_Core_Labeling_Worksorder_No);
   rweight    := Read_Float_Value(K_DB4101_Core_Labeling_Weight);
   rLength    := Read_Float_Value(K_DB4101_Core_Labeling_length);

   // Now the pain in the arse !!!
   // So the Koch system wont send us the employee number with the roll weight,length etc...

  ParamFailure := false;

  if not Fetch_Running_Koch_Jobs(zWord, izclock, izm) then
    Begin
      // Crashed asking for running jobs info
      Debug_Logging('Koch Error: works order '+zword.ToString+' NOT found in DB4103 Table of running jobs on Koch',clWebSalmon);
      ParamFailure := true;
    End;


  // Check Values are valid, Works Order > 0, Weight > 1, Length > 20
  if iAuditNo = 0 then
   Begin
     Debug_Logging('CORE Create Request iAudit Failure = :'+iAuditNo.ToString,clWebSalmon);
     ParamFailure := true;
   End;
  if zWord = 0 then
   Begin
     Debug_Logging('CORE Create Request zword Failure = :'+zword.ToString,clWebSalmon);
     ParamFailure := true;
   End;
  if rWeight < Precision then
   Begin
     Debug_Logging('CORE Create Request rWeight Failure = :'+rWeight.ToString,clWebSalmon);
     ParamFailure := true;
   End;

  if rLength < Precision then
   Begin
     Debug_Logging('CORE Create Request rLength Failure = :'+rLength.ToString,clWebSalmon);
     ParamFailure := true;
   End;


   if ParamFailure = true then
    Exit;


  // Go Create a new Pallet, and roll if required, then return the Pallet and Roll number
   CreateRoll(iAuditNo,Auditdate,zword,rweight,rlength,izclock,zpallet,zpitem,izm);

  // Send new roll and pallet numbers to Koch
  WriteNodeValue(K_DB4101_Core_Labeling_Roll_No,zpitem);
  WriteNodeValue(K_DB4101_Core_Labeling_Pallet_No,zpallet);
  // Now Print the Roll Label ....   !!!!!  BLOCKING !!!!! .. Maybe Thread for roll print
  if CheckBoxFullDebug.checked then
   Begin

     Debug_Logging('>>>> CORE Created : Pallet :'+ zpallet.tostring +' , Roll :'+ zpitem.tostring,clLime);
     Debug_Logging('         W/Ord    : '+ zword.tostring +' , Weight(Kg) :'+ format('%5.2f',[rWeight]),clLime);
     Debug_Logging('         Length(M): '+ format('%5.2f',[rLength]) +' , Clock :'+ izclock.tostring,clLime);
     Debug_Logging('      Machine(ZM) : '+ izm.tostring ,clLime);
     Debug_Logging('      TimeStamp   : '+ FormatDateTime('ddd dd mmm yyyy hh:nn:ss',Auditdate),clLime);

   End;
End;

procedure TFormMain_Koch.CreateNew_Slitting_Roll(const zword, zm,
  AuditNO: Integer; const audittime: TDateTime; const weight, length: Double;
  var zpallet, zpitem: Integer);
begin

end;

procedure TFormMain_Koch.PrintLabelCoreDB4102;
var
   CoreRoll    : Integer;
   CorePallet  : Integer;

Begin
   // Fetch What to print from Koch
  CoreRoll    := Read_int_Value(K_DB4101_Core_Labeling_CoreRoll);

  if CheckBoxFullDebug.checked then
    Debug_Logging('Core # From Koch :'+ CoreRoll.tostring ,clLime);

  // New function to find Pallet for Roll number supplied.
  CorePallet := Fetch_Pallet_For_zpitm(CoreRoll);

  if CheckBoxFullDebug.checked then
    Debug_Logging('Print Core , Convert Core#  :'+ CoreRoll.tostring +' ,to Pallet :'+ CorePallet.tostring,clLime);

  if CorePallet > 0 then
   Begin
    if CheckBoxFullDebug.checked then
      Debug_Logging('Request to print core label : Pallet # '+CorePallet.tostring +' zpitem = :'+CoreRoll.ToString ,clSkyBlue);

    Print_Core_Label_DB4102(CorePallet,CoreRoll, KochItemPrinterName ); /// Blocking Risk Here ???

    // Now Print the Roll Label ....   !!!!!  BLOCKING !!!!! .. Maybe Thread for roll print
    if CheckBoxFullDebug.checked then
      Debug_Logging('>>>> Core label printed : Pallet :'+ CorePallet.tostring +' , Roll :'+ CoreRoll.tostring,clLime);

   End
  else
    Debug_Logging('Core label Print failed, Rx''d Core = '+CoreRoll.ToString +' # finds pallet ' +CorePallet.toString+' Bad',clSkyBlue);

End;


Procedure TFormMain_Koch.Print_Pallet_ID_Label_DB4124(iZPallet                : Integer;
                                               KochPalletIDPrinterName : String ); /// Blocking Risk Here ???
var
 WIDprintform      : TFormPrintPalletID;
 sPallets          : String;
 IDtrans           : TUniTransaction;
Begin
 Try
  IDtrans      := TUnitransaction.create(nil);
  IDtrans.DefaultConnection := DMSIVADATA.UniConnectionMain;

  WIDprintform := TFormPrintPalletID.Create(self);
  WIDprintform.Setup_ParentTransaction(IDTrans);
  sPallets     := izpallet.tostring;
  WIDprintform.Print_Production_IDs(SPallets ,1 {1 Label},KochPalletIDPrinterName);
 Finally
   if IDtrans.active then
    IDtrans.rollback;
   FreeAndNil(IDTrans);
   FreeandNil(WIDprintform);
  End;

End;


Procedure TFormMain_Koch.Print_A5_Label_DB4125(ZPallet                     :Integer;
                                               iPrintSide                  :Integer;
                                               Selected_Koch_Pallet_A5_PrinterName :String;
                                               var iError                  :Integer);// iError=0 = Ok
var
 Wpf                     : TFormRBWeighPrint;
 UniqueryCore            : TUniQuery;
 Selected_Label          : Integer;
 izpitm                  : Integer;
 iNumberofRollsOnPallet  : Integer;
 ImpersonatedStation     : TStationType;
 iCopies                 : Integer;
 bFinalStatePallet       : Boolean;
Begin
 Selected_Label  := 0;
 iError          := 0;

 Try
        Wpf := TFormRBWeighPrint.Create(self);
        Wpf.currenttransaction := UniTransactionKochMain;
        Wpf.ForceTransactions(UniTransactionKochMain);  // This sets the actual UniQuery Comps , Not done in line above
        UniqueryCore             := TUniQuery.Create(Self);
        UniqueryCore.Connection  := DMSIVADATA.UniConnectionMain;   //  might need unique ones if in a thread
        UniqueryCore.Transaction := UniTransactionKochMain;
        // fetch the core label type, the label for each side and the actual pallet contents
        UniqueryCore.SQL.Clear;
        UniqueryCore.SQL.add('select p.zpallet,p.zpstate, c.zcplt, c.zcplt2, c.zcplt3 ');
        UniqueryCore.SQL.add(',c.zcplt4,c.ZPLBLCNT , c.zpltsmry, s.zpstate as Final_State ');
        UniqueryCore.SQL.add(',count(i.zpitm) as RollsOnPallet');
        UniqueryCore.SQL.add('from papallet p');
        UniqueryCore.SQL.add('join papitm i on i.zpallet   = p.zpallet ');
        UniqueryCore.SQL.add('join worksord w  on w.zword  = p.zword');
        UniqueryCore.SQL.add('join acspec   s  on s.zspec  = w.zspec');
        UniqueryCore.SQL.add('join ord2wks  o2 on o2.zword = w.zword ');
        UniqueryCore.SQL.add('join accst    c  on c.zcst   = o2.zcst ');
        UniqueryCore.SQL.add('where p.zpallet = ' + zpallet.tostring );
        UniqueryCore.SQL.add('Group by p.zpallet,p.zpstate, c.zcplt, c.zcplt2, c.zcplt3  ');
        UniqueryCore.SQL.add(',c.zcplt4,c.ZPLBLCNT , c.zpltsmry, s.zpstate');
        UniqueryCore.open;

    // iRollsOnPallet  := UniqueryCore.FieldByname('RollsOnPallet').AsInteger;
    // Put the pallet contents into the correct category
    //  1 = Weighing
    //  2 = conversion
    //  etc...

    Case UniqueryCore.FieldByName('zpstate').AsInteger of
        KP_FILM,KP_FILM_QUAR           : ImpersonatedStation := Weighing_Station;
        KP_PRINT,KP_PRINT_QUAR         : ImpersonatedStation := Printing_Station;
        KP_LAMINATED,KP_LAMINATED_QUAR : ImpersonatedStation := Lamination;
        KP_SLITTING,KP_SLITTING_QUAR   : ImpersonatedStation := Slitting_Station;
        KP_BAG,KP_SHEET,
        KP_PRINT_BAG,
        KP_PRINT_SHEET,
        KP_PRINT_BAG_QUAR,
        KP_PRINT_SHEET_QUAR             : ImpersonatedStation := Conversion_Station;
        KP_FFS,
        KP_FFS_PRINTED,KP_FFS_QUAR      : ImpersonatedStation := FFS;
        KP_NGR,KP_NGR_Film,KP_NGR_QUAR  : ImpersonatedStation := NGR_FeedRolls_Weighing;
    Else
        ImpersonatedStation := Weighing_Station;
    end;

    bFinalStatePallet := UniqueryCore.FieldByName('zpstate').AsInteger = UniqueryCore.FieldByName('Final_State').AsInteger;

    // If Finalstate = true and No default pallet side 1 setup then default to

    case iPrintSide of
          1 : if UniqueryCore.FieldByName('zcplt' ).ASInteger > 0 then
                Selected_Label := UniqueryCore.FieldByName('zcplt' ).ASInteger  // Fetch Label for Side 1  Standard Siva Label ONLY side 1
              else  // Special Case Side 1 Not Setup..Use Standard Siva Pallet Labell..Adrian Rule 198
                Selected_Label := K_Siva_A5_Standard_LAbel ;
          2 : if UniqueryCore.FieldByName('zcplt2' ).ASInteger > 0 then
                Selected_Label := UniqueryCore.FieldByName('zcplt2').ASInteger ; // Fetch Label for Side 2  Standard Siva Pallet Summary Side 2
          3 : if UniqueryCore.FieldByName('zcplt3' ).ASInteger > 0 then
                Selected_Label := UniqueryCore.FieldByName('zcplt3').ASInteger ; // Fetch Label for Side 3  .. Customer specific labels Side 3
          4 : if UniqueryCore.FieldByName('zcplt4' ).ASInteger > 0 then
                Selected_Label := UniqueryCore.FieldByName('zcplt4').ASInteger ; // Fetch Label for Side 4  .. Customer specific labels Side 4
      else
        begin
          iError := K_Koch_IllegalSide_supplied; // 1 = Illegal side to print from Koch
          exit; // No label required for unknown/Illegal side....Bail !!!..Let Koch Timeout error
        end;
    end;

    // SITUATION: What to do if only 1 side is programed for the customer and the Koch system asks for side 2 ????
    // I cant send an error, i can notify the User, but cant tell Koch !!!
    //My Solution:  Rather than print an unwanted label I will not print anything, the Koch system
    // "should" timeout waiting for the label they shouldnt be asking me for, then the operator will
    // see the error on my debug screen.... If the PC is near the Koch machine !!!!
   if (Selected_Label = 0) then
    begin
     iError :=  K_Koch_NoPalletLabelForSide ; // 2 = No Valid Pallet setup for this side
     Exit ;// NOthing to print on this side !!!...Failure
    end;

    if (Assigned(wpf)) Then
      begin
            izpitm   := 0; //0 = pallet printing mode
            // Need to get rolls per pallet and layers for OSI Pallet labels...Dont ask!!
            iNumberofRollsOnPallet := UniqueryCore.FieldByName('RollsOnPallet').AsInteger;

            // *** WARNING *** If side 2 and Print Summary CHECKBOX in customers set then override
            //                 side 2 with standard Siva Summary !!!!
            // Removed 9th Aug 2022, as now all summary sheets MUST be defined in the Customers
            // Pallet label layout in ACCST
//            if ((UniqueryCore.FieldByName('ZPLTSMRY').ASBoolean = TRUE)  AND (iPrintSide = 2 ))then
//             begin
//              Selected_Label := K_Siva_A5_Summary_Label ; // Override Selected label
//             end;

          // If Pallet is an NGR pallet then print LARGE ***NGR** placard and a Siva type NGR pallet label
            if UniqueryCore.FieldByName('ZPSTATE').AsInteger = KP_NGR {50} then
              begin
                if UniqueryCore.FieldByName('ZPLBLCNT').AsInteger > 0 then
                 iCopies := UniqueryCore.FieldByName('ZPLBLCNT').AsInteger
                Else
                  iCopies := WeighPalletLabelCopies; // New 24th Jan 2004
                wpf.PrintPallet_A5_NGR_STICKER(zpallet, izpitm,iCopies,Selected_Koch_Pallet_A5_PrinterName);
              end
            else
              begin
                 // Retired Special Labels
                 //  K_PandGPalletLabels        : wpf.Print_Procter_And_Gamble  (zpallet,izpitm,  PalletPrinterName); {P & G Labels }
                 //  K_GP_PalletLabels          : wpf.Print_Georgia_Pacific     (zpallet,izpitm,  PalletPrinterName); {Georgia Pacific Labels }
                 //  K_MYDI01_PalletLabels      : wpf.Print_MYDI01_SSCC         (zpallet,izpitm,  1,PalletPrinterName);
                 //  K_Bell02_PalletLabels      : wpf.PrintPalletSummary_BELL02 (zpallet,izpitm,  PalletPrinterName);
                 //  K_BRAY02_PalletLabels      : wpf.Print_BRAY02_Pallet_Sum   (zpallet,izpitm,  PalletPrinterName); // Special Bray02
               if bFinalStatePallet then
                Begin
                      //Print selected pallet label to the side requested
                      CASE Selected_Label of
                       K_BNM_Pallet_Labels        :{ 3}     wpf.Print_BNM_Pallets         (zpallet,izpitm,  1{Only 1 per side},Selected_Koch_Pallet_A5_PrinterName); {BNM Labels }
                       K_Plain_Pallet_Labels      :{ 4}     wpf.PrintCustomPallet_A5      (zpallet,izpitm,  1{Only 1 per side},Selected_Koch_Pallet_A5_PrinterName);
                       K_OSI_PalletLabels         :{ 7}     wpf.Print_OSI_PALLET          (zpallet,izpitm,  iNumberofRollsOnPallet,1{Only 1 per side},Selected_Koch_Pallet_A5_PrinterName);
                       K_CLAR06_PalletLabels      :{ 8}     wpf.Print_CLAR06_PALLET       (zpallet,izpitm,  1{Only 1 per side},Selected_Koch_Pallet_A5_PrinterName);
                       K_BART03_PalletLabels      :{12}     wpf.Print_BART03_PALLET       (zpallet,izpitm,  iNumberofRollsOnPallet,1{Only 1 per side},Selected_Koch_Pallet_A5_PrinterName);
                       K_FARMxx_PalletLabels      :{15 old} wpf.Print_Farmxx_Pallet       (zpallet,izpitm,  iNumberofRollsOnPallet, 1 {Only 1 per side} ,Selected_Koch_Pallet_A5_PrinterName );
                       K_NGR_PalletLabels         :{16}     wpf.PrintPallet_NGR_A5        (zpallet,izpitm,  1 {Only 1 per side},Selected_Koch_Pallet_A5_PrinterName);
                       K_FARMxx_2D_PalletLabels   :{24}     wpf.Print_Farmxx_2D_Pallet    (zpallet,izpitm,  iNumberofRollsOnPallet, 1 {Only 1 per side},Selected_Koch_Pallet_A5_PrinterName );
                       K_THATCHERS_PalletLabels   :{18}     wpf.Print_THATCHERS_A5        (zpallet,izpitm,  1{Only 1 per side},Selected_Koch_Pallet_A5_PrinterName); // Special Thatchers SCC Label
                       K_CORB01_PalletLabels      :{22}     wpf.Print_CORB01_Pallet       (zpallet,izpitm,  iNumberofRollsOnPallet,1 {Only 1 per side},Selected_Koch_Pallet_A5_PrinterName);
                       K_Siva_A5_Summary_Label    :{26}     wpf.PrintPalletSummary_A5     (zpallet,izpitm,  1 {Only 1 per side},Selected_Koch_Pallet_A5_PrinterName);  // Normal Standard summary pallet label =  25; // Standard Siva Pallet Summary sheet for Koch system change over
                       K_SIva_A5_Standard_LAbel   :{25}     wpf.PrintPallet_A5            (zpallet,izpitm,ImpersonatedStation ,1, Selected_Koch_Pallet_A5_PrinterName );   // Standard Pallet Labels  26; // Standard Siva Pallet A5 Label for Koch system change over
                       K_Siva_A5_SMARTPOLY_labels :{27}     wpf.Print_SKY_A5_SMARTPOLLY   (zpallet,izpitm,  1 {Only 1 per side},Selected_Koch_Pallet_A5_PrinterName); // New Smartpoly A5 Label LANDSCAPE !!!
                       K_FARMxx_2D_SummaryLabels  :{29}     wpf.PrintFARMXX_2D_Summary_A5 (zpallet,         1 {Only 1 per side},Selected_Koch_Pallet_A5_PrinterName );
                      Else  {Print a Standard Pallet Label}
                         wpf.PrintPallet_A5(zpallet, izpitm,  ImpersonatedStation ,  1, Selected_Koch_Pallet_A5_PrinterName );  // Normal A5 Size
                     END; // Case
                 end // If bFinalStatePallet
               Else // Only Print Standard Siva Label if WIP eg not final product
                wpf.PrintPallet_A5(zpallet,izpitm,ImpersonatedStation ,1, Selected_Koch_Pallet_A5_PrinterName );   // Standard Pallet Labels  25; // Standard Siva Pallet A5 Label for Koch system change over
              End;

       end; // if assigned(wpf)

   Finally
      Wpf.free;
      UniqueryCore.free;
    End;

end;



Procedure TFormMain_Koch.Print_Core_Label_DB4102(const zpallet :integer; const zpitm :integer ;const sTargetPrinter :String);
var
 Wprintform      : TFormRBWeighPrint;
 UniqueryCore    : TUniQuery;
 iRollsOnPallet  : Integer;
  iCore_Label_Type: Integer;
Begin

 Try
   try
        Wprintform := TFormRBWeighPrint.Create(self);
        Wprintform.currenttransaction := UniTransactionKochMain;
        Wprintform.ForceTransactions(UniTransactionKochMain);  // This sets the actual UniQuery Comps , Not done in line above
        UniqueryCore := TUniQuery.Create(Self);
        UniqueryCore.Connection  := DMSIVADATA.UniConnectionMain;   //  might need unique ones if in a thread
        UniqueryCore.Transaction := UniTransactionKochMain;
        // fetch the core label type
        UniqueryCore.SQL.Clear;
        UniqueryCore.SQL.add('select p.zpallet, c.zcplt, c.zcorelbl ,count(i.zpitm) as RollsOnPallet');
        UniqueryCore.SQL.add('from papallet p');
        UniqueryCore.SQL.add('join papitm i on i.zpallet = p.zpallet ');
        UniqueryCore.SQL.add('join worksord w  on w.zword  = p.zword');
        UniqueryCore.SQL.add('join ord2wks  o2 on o2.zword = w.zword ');
        UniqueryCore.SQL.add('join accst    c  on c.zcst   = o2.zcst ');
        UniqueryCore.SQL.add('where p.zpallet >= ' +zpallet.tostring);
        UniqueryCore.SQL.add('Group by p.zpallet, c.zcplt, c.zcorelbl ');
        UniqueryCore.open;

        iRollsOnPallet  := UniqueryCore.FieldByname('RollsOnPallet').AsInteger;


        // PRINT  CORE LABELS  SECTION
        if (Assigned(Wprintform) )  Then
          begin
        /// **************   P R I N T   C O R E    L A B E L S    ******************
        ///
        ///  IF the "SPECIAL CORE" label setting in the customer table has been set > 0 then use this core label
        ///  instead of the hardcoded core corresponding to the customer pallet selection
        ///
          iCore_Label_Type := UniqueryCore.FieldByName('zcorelbl').ASInteger; // See if core override setup?

          if iCore_Label_Type = 0 then
             iCore_Label_Type := UniqueryCore.FieldByName('zcplt').ASInteger ; // use Pallet Selctor instead..Default

          case  iCore_Label_Type  of
            K_Plain_Pallet_Labels:        Wprintform.PrintCustomItem(zpallet, zpitm, 1, sTargetPrinter );

              // Custom Roll Label ..Plain
            K_Bell02_PalletLabels:        Wprintform.PrintCustomItem_BELL02(zpallet, zpitm, 1,sTargetPrinter); // Custom Roll Label ..Plain

            K_GRON01_PalletLabels:
              Begin // PRINT BOTH For a Roll Label
//                Wprintform.PrintItem(zpallet, zpitm, 1, KochItemPrinterName);
                // Siva Std Roll Label
                // Custom Roll Label ..GRON01 A5 **** WARNING PALLET SIZE ROLL LABELS !!!!
                Wprintform.PrintCustomItem_GRON01(zpallet, zpitm, 1,sTargetPrinter);
              End;

            K_OSI_PalletLabels:
              Begin
      //          // Client wants all large roll lables (these are just pallet labels actually)
      //          // to indicate 6 rolls if the pallet
      //          iRollsOnPallet := iLayers * iRollsLayer;
      //          // DO NOT PRINT STD Label Bob 17:33 Mon 15th Feb 2016 wPrintForm.PrintItem(iZpallet,iZpitm); // Siva Std Roll Label
      //          Wprintform.Print_OSI_PALLET(izpallet, izpitm, iRollsOnPallet,
      //            1 { one label only } , PalletPrinterName);
              End;

            K_WORL01_PalletLabels:
              Begin
                Wprintform.PrintCustomItem_WORL01(zpallet, zpitm, 1,sTargetPrinter);
                // Custom Roll Label ..WORL01 Very Sparse Roll Label
              End;

            K_SKYW03_PalletLabels:
              Begin
                Wprintform.PrintItem(zpallet, zpitm, 1, sTargetPrinter)
                // Siva Std Plain Roll Label
                // also fire Bobs new labels from here for FILM 1, 2 , 3 by using the new layer ID "ZLAMLAY" in the spec
              End;

            K_FARMxx_PalletLabels:
              begin // New 13th Nov 2018 FARM04 for Olivier Dubief Farm04/06
                Wprintform.Print_Farmxx_Pallet(zpallet, zpitm, iRollsOnPallet,1, sTargetPrinter);
              end;

            K_FARMxx_2D_PalletLabels:
              begin // New 1st Aug 2021 FARM04 Trial 2D bar codes
                //Wprintform.Print_Farmxx_2D_Pallet(zpallet, zpitm, iRollsOnPallet,1, sTargetPrinter);
                Wprintform.PrintFARMXX_2D_Item(zpallet,zpitm ,1 ,sTargetPrinter); // FARM08 COre labels to Inner and Outer
              end;

            K_Siva_A5_SMARTPOLY_labels :
              begin
                Wprintform.Print_SKY_CORE_SMARTPOLLY(zpallet, zpitm, 1, sTargetPrinter); // New Smart poly core labels
              end;

          Else // Do Standard with logo label
            Wprintform.PrintItem(zpallet, zpitm, 1, sTargetPrinter)
            // Siva Std Plain Roll Label
          end;

         end;

   Except
     on e:exception do
      Debug_Logging('Failed Printing Core.  SQL : '+
                     UniqueryCore.SQL.text +
                     '  Pallet # '+
                     zpallet.tostring +
                     ' Roll # ' +
                     zpitm.ToString +
                     ' Error : ' +
                     E.Message,clWebSalmon);
   end;

   Finally
      Wprintform.free;
      UniqueryCore.free;
    End;
End;


Procedure TFormMain_Koch.CreateRoll(const iAuditNo   : integer;
                                    const Auditdate  : TDateTime;
                                    const zword      : Integer;
                                    const rweight    : Double;
                                    const rlength    : Double;
                                    const izclock    : Integer;
                                    var   zpallet    : Integer;
                                    var   zpitem     : Integer;
                                    const izm        : Integer);
Begin
      (*
       1 : Check Works order Valid
       2 : See if any open pallets for this job
       3 : if open get zpallet
       4 : if not then create new pallet
       5 : Create pallet SEQ number , Employee, worksord etc...Details from Spec
       6 : Create new Roll on this pallet
       7 : if total rolls = (Rolls/Layer) * (Layers * Pallet) then Close Pallet
       8 : Return all information required for Koch.
      *)
    UniQueryCoreCreate.close;
    UniQueryCoreCreate.sql.clear;
    UniQueryCoreCreate.SQL.Add('   /* Validate Worksorder');
    UniQueryCoreCreate.SQL.Add('   1 : Check Works order Valid');
    UniQueryCoreCreate.SQL.Add('   2 : See if any open pallets for this job');
    UniQueryCoreCreate.SQL.Add('   3 : if open get zpallet');
    UniQueryCoreCreate.SQL.Add('        Calc Seq Number, Etc');
    UniQueryCoreCreate.SQL.Add('   4 : if not then create new pallet');
    UniQueryCoreCreate.SQL.Add('   5 : Create pallet SEQ number , Employee, worksord etc...Details from Spec');
    UniQueryCoreCreate.SQL.Add('   6 : Create new Roll on this pallet');
    UniQueryCoreCreate.SQL.Add('   7 : if total rolls = (Rolls/Layer) * (Layers * Pallet) then Close Pallet');
    UniQueryCoreCreate.SQL.Add('   8 : Return all information required for Koch.');
    UniQueryCoreCreate.SQL.Add('  */');
    UniQueryCoreCreate.SQL.Add('execute block');
    UniQueryCoreCreate.SQL.Add('returns (');
    UniQueryCoreCreate.SQL.Add('    ZPALLET    INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZFPALLET    INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZPDATENEW   TIMESTAMP ,');
    UniQueryCoreCreate.SQL.Add('    ZPDATEKILL  TIMESTAMP,');
    UniQueryCoreCreate.SQL.Add('    ZPSCNTIME   TIMESTAMP,');
    UniQueryCoreCreate.SQL.Add('    ZPUSERNEW   VARCHAR(5),');
    UniQueryCoreCreate.SQL.Add('    ZPUSERKILL  VARCHAR(5),');
    UniQueryCoreCreate.SQL.Add('    ZM          INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZMKILL      INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZPLT        INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZWORD       INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZPLOC       INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZPSTATE     INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZPUSED      LOGICAL ,');
    UniQueryCoreCreate.SQL.Add('    ZPDISPATCH  LOGICAL ,');
    UniQueryCoreCreate.SQL.Add('    ZPINSP      INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZWOPINSP    INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZPBOXLAYER  INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZPPLAYPLT   INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZPBAGSBOX   INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZPSEQ       INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZREBOOK     LOGICAL ,');
    UniQueryCoreCreate.SQL.Add('    ZPOPEN      LOGICAL ,');
    UniQueryCoreCreate.SQL.Add('    ZPQUAR      LOGICAL ,');
    UniQueryCoreCreate.SQL.Add('    ZPPUSER     VARCHAR(5),');
    UniQueryCoreCreate.SQL.Add('    ZPSCANBY    INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZMKILLWORD  INTEGER,');
    UniQueryCoreCreate.SQL.Add('/* PAPITM TABLE */');
    UniQueryCoreCreate.SQL.Add('    ZPITM       INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZPITMX      INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    --ZPALLET     INTEGER , Defined in Pallet Record');
    UniQueryCoreCreate.SQL.Add('    ZITMWGT     NUMERIC(10,5) ,');
    UniQueryCoreCreate.SQL.Add('    ZPCOREWGT   NUMERIC(10,5),');
    UniQueryCoreCreate.SQL.Add('    ZPGROSS     LOGICAL ,');
    UniQueryCoreCreate.SQL.Add('    ZPIUSERLEN  LOGICAL ,');
    UniQueryCoreCreate.SQL.Add('    ZPIUSER     VARCHAR(10),');
    UniQueryCoreCreate.SQL.Add('    ZPIDATE     TIMESTAMP,');
    UniQueryCoreCreate.SQL.Add('    ZPILEN      NUMERIC(10,5),');
    UniQueryCoreCreate.SQL.Add('    ZAUDIT      INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZIMP        INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZIMGCOUNT   INTEGER ,');
    UniQueryCoreCreate.SQL.Add('    ZCORE       VARCHAR(10),');
    UniQueryCoreCreate.SQL.Add('    ZROLLSEQ    INTEGER,');
    UniQueryCoreCreate.SQL.Add('    ZPQTY       INTEGER, -- New Conv Bag Count');
    UniQueryCoreCreate.SQL.Add('/* Misc calc info */');
    UniQueryCoreCreate.SQL.Add('    NewPallet   int,   -- 1= new pallet Created');
    UniQueryCoreCreate.SQL.Add('    zslplt      int ,');
    UniQueryCoreCreate.SQL.Add('    zemp        int,');
    UniQueryCoreCreate.SQL.Add('    zcorewgt    Numeric(10,5),  -- Core Kg/M');
    UniQueryCoreCreate.SQL.Add('    zslwidth    Numeric(10,5),  -- Core width and roll width');
    UniQueryCoreCreate.SQL.Add('    zrptlen     Numeric(10,5),');
    UniQueryCoreCreate.SQL.Add('    zimages     Integer,        -- images per zrptlen');
    UniQueryCoreCreate.SQL.Add('    zusegross   LOGICAL,');
    UniQueryCoreCreate.SQL.Add('    zslrplay    integer,');
    UniQueryCoreCreate.SQL.Add('    zsllayplt   integer,');
    UniQueryCoreCreate.SQL.Add('    RollsOnPallet Integer');
    UniQueryCoreCreate.SQL.Add('  )');
    UniQueryCoreCreate.SQL.Add('as   /* ******  SUPER IMPORTANT PARAMETERS REQUIRED  ******** */');
    UniQueryCoreCreate.SQL.Add('    Declare variable zword_in   int         =  '+zword.ToString   +' ;');
    UniQueryCoreCreate.SQL.Add('    Declare variable zm_in      int         =  '+izm.tostring     +' ;');
    UniQueryCoreCreate.SQL.Add('    declare variable zclock     int         =  '+izclock.tostring +' ;');
    UniQueryCoreCreate.SQL.Add('    declare variable weight_in  floatP2     =  '+Format('%5.1f',[rWeight]) +' ;');
    UniQueryCoreCreate.SQL.Add('    declare variable Length_in  floatp2     =  '+Format('%5.1f',[rlength]) +' ;');
    UniQueryCoreCreate.SQL.Add('    declare variable audit_in   int         =  '+iAuditNo.ToString         +' ;');
    UniQueryCoreCreate.SQL.Add('    declare variable AuditTime_in TimeStamp = '''+ formatdatetime('dd mmm yyyy hh:nn:ss', AuditDate) +''';');
    UniQueryCoreCreate.SQL.Add('');
    UniQueryCoreCreate.SQL.Add('    declare variable bDoUpdate  int      = 1; /* 1 = Do update */');
    UniQueryCoreCreate.SQL.Add('begin');
    UniQueryCoreCreate.SQL.Add('        select w.zword ,s.zslplt ,s.zslcore, r.zcorewgt ,s.zslwidth');
    UniQueryCoreCreate.SQL.Add('         ,p.zrptlen, p.zimages ,c.zusegross ,s.zslrplay, s.zsllayplt');
    UniQueryCoreCreate.SQL.Add('        from         worksord  w');
    UniQueryCoreCreate.SQL.Add('                join acspec    s on s.zspec = w.zspec');
    UniQueryCoreCreate.SQL.Add('                join accst     c on c.zcst  = s.zcst');
    UniQueryCoreCreate.SQL.Add('                join acscore   R on r.zcore = s.zslcore');
    UniQueryCoreCreate.SQL.Add('           left join acsprint  p on p.zspec = s.zspec');
    UniQueryCoreCreate.SQL.Add('        where w.zword = :zword_in');
    UniQueryCoreCreate.SQL.Add('        into zword , zslplt ,zcore , zcorewgt ,zslwidth ,zrptlen,');
    UniQueryCoreCreate.SQL.Add('             zimages ,zusegross ,zslrplay, zsllayplt;');
    UniQueryCoreCreate.SQL.Add('        /* Convert zclock into zemp No */');
    UniQueryCoreCreate.SQL.Add('        select e.Zemp');
    UniQueryCoreCreate.SQL.Add('        from employee e');
    UniQueryCoreCreate.SQL.Add('        where e.zclock = :zclock');
    UniQueryCoreCreate.SQL.Add('        into zemp;');

    UniQueryCoreCreate.SQL.Add('        /* Fetch current OPEN SLITTING Pallet ...IF one exists */');
    UniQueryCoreCreate.SQL.Add('        Select first 1 zpallet, zfpallet, zpdatenew, zpdatekill, zpscntime');
    UniQueryCoreCreate.SQL.Add('                                 , zpusernew, zpuserkill, zm, zmkill, zplt, zword');
    UniQueryCoreCreate.SQL.Add('                                 , zploc, zpstate, zpused, zpdispatch, zpinsp');
    UniQueryCoreCreate.SQL.Add('                                 , zwopinsp, zpboxlayer, zpplayplt, zpbagsbox');
    UniQueryCoreCreate.SQL.Add('                                 , zpseq, zrebook, zpopen, zpquar, zppuser');
    UniQueryCoreCreate.SQL.Add('                                 , zpscanby, zmkillword');
    UniQueryCoreCreate.SQL.Add('        from papallet p');
    UniQueryCoreCreate.SQL.Add('        where p.zpopen = ''T''');
    UniQueryCoreCreate.SQL.Add('        and p.zword = :zword_in');
    UniQueryCoreCreate.SQL.Add('        and p.zpstate = ' + KP_SLITTING.ToString);
    UniQueryCoreCreate.SQL.Add('        into zpallet, zfpallet, zpdatenew, zpdatekill, zpscntime');
    UniQueryCoreCreate.SQL.Add('                                 , zpusernew, zpuserkill, zm, zmkill, zplt, zword');
    UniQueryCoreCreate.SQL.Add('                                 , zploc, zpstate, zpused, zpdispatch, zpinsp');
    UniQueryCoreCreate.SQL.Add('                                 , zwopinsp, zpboxlayer, zpplayplt, zpbagsbox');
    UniQueryCoreCreate.SQL.Add('                                 , zpseq, zrebook, zpopen, zpquar, zppuser');
    UniQueryCoreCreate.SQL.Add('                                 , zpscanby, zmkillword;');
    UniQueryCoreCreate.SQL.Add('         /* If Null then we need to create a new pallet */');


    UniQueryCoreCreate.SQL.Add('        if (coalesce(zpallet,0) = 0 ) then /* Create a new pallet */');
    UniQueryCoreCreate.SQL.Add('         begin');
    UniQueryCoreCreate.SQL.Add('           /* No pallet  */');
    UniQueryCoreCreate.SQL.Add('            Select max(zpseq) /* Lets calc next pseq No */');
    UniQueryCoreCreate.SQL.Add('            from papallet px');
    UniQueryCoreCreate.SQL.Add('            where px.zword = :zword');
    UniQueryCoreCreate.SQL.Add('            and px.zpstate in (9,22) -- *** MUST *** also consider quarantined Slit rolls');
    UniQueryCoreCreate.SQL.Add('            into zpseq;');
    UniQueryCoreCreate.SQL.Add('            zpseq = coalesce(zpseq, 0) + 1;');
    UniQueryCoreCreate.SQL.Add('            zpallet      = Gen_id(papallet_gen,1);');
    UniQueryCoreCreate.SQL.Add('            zfpallet     = 0;');
    UniQueryCoreCreate.SQL.Add('            zpdatenew    = Current_TimeStamp;');
    UniQueryCoreCreate.SQL.Add('            zpdatekill   = Null;');
    UniQueryCoreCreate.SQL.Add('            zpscntime    = Null;');
    UniQueryCoreCreate.SQL.Add('            zpusernew    = zemp;'); // EMERGENCY FIX FOR 6 digit zclock No, Use zemp instead
    UniQueryCoreCreate.SQL.Add('            zpuserkill   = Null;');
    UniQueryCoreCreate.SQL.Add('            zm           = zm_in;');
    UniQueryCoreCreate.SQL.Add('            zmkill       = 0;');
    UniQueryCoreCreate.SQL.Add('            zplt         = zslplt;');
    UniQueryCoreCreate.SQL.Add('            --zword      = zword;');
    UniQueryCoreCreate.SQL.Add('            zploc        =  1; -- 1 = Warehouse / New Production');
    UniQueryCoreCreate.SQL.Add('            zpstate      = 9 ; --9  = Slit Product;');
    UniQueryCoreCreate.SQL.Add('            zpused       = ''F'';');
    UniQueryCoreCreate.SQL.Add('            zpdispatch   = ''F'';');
    UniQueryCoreCreate.SQL.Add('            zpinsp       = 0;');
    UniQueryCoreCreate.SQL.Add('            zwopinsp     = 0;');
    UniQueryCoreCreate.SQL.Add('            zpboxlayer   = NULL;');
    UniQueryCoreCreate.SQL.Add('            zpplayplt    = 0;');
    UniQueryCoreCreate.SQL.Add('            zpbagsbox    = 0;');
    UniQueryCoreCreate.SQL.Add('            --zpseq        = zpseq;');
    UniQueryCoreCreate.SQL.Add('            zrebook      = ''F'';');
    UniQueryCoreCreate.SQL.Add('            zpopen       = ''T'';');
    UniQueryCoreCreate.SQL.Add('            zpquar       = ''F'';');
    UniQueryCoreCreate.SQL.Add('            zppuser      = ''KOCH'';');
    UniQueryCoreCreate.SQL.Add('            zpscanby     = Null;');
    UniQueryCoreCreate.SQL.Add('            zmkillword   = null;');
    UniQueryCoreCreate.SQL.Add('            NewPallet    = zpallet;');
    UniQueryCoreCreate.SQL.Add('            if (bDoUpdate = 1) then');
    UniQueryCoreCreate.SQL.Add('              begin');
    UniQueryCoreCreate.SQL.Add('                insert into papallet  (zpallet, zfpallet, zpdatenew, zpdatekill, zpscntime');
    UniQueryCoreCreate.SQL.Add('                                 , zpusernew, zpuserkill, zm, zmkill, zplt, zword');
    UniQueryCoreCreate.SQL.Add('                                 , zploc, zpstate, zpused, zpdispatch, zpinsp');
    UniQueryCoreCreate.SQL.Add('                                 , zwopinsp, zpboxlayer, zpplayplt, zpbagsbox');
    UniQueryCoreCreate.SQL.Add('                                 , zpseq, zrebook, zpopen, zpquar, zppuser');
    UniQueryCoreCreate.SQL.Add('                                 , zpscanby, zmkillword )');
    UniQueryCoreCreate.SQL.Add('                       values (:zpallet, :zfpallet, :zpdatenew, :zpdatekill, :zpscntime');
    UniQueryCoreCreate.SQL.Add('                                 , :zpusernew, :zpuserkill, :zm, :zmkill, :zplt, :zword');
    UniQueryCoreCreate.SQL.Add('                                 , :zploc, :zpstate, :zpused, :zpdispatch, :zpinsp');
    UniQueryCoreCreate.SQL.Add('                                 , :zwopinsp, :zpboxlayer, :zpplayplt, :zpbagsbox');
    UniQueryCoreCreate.SQL.Add('                                 , :zpseq, :zrebook, :zpopen, :zpquar, :zppuser');
    UniQueryCoreCreate.SQL.Add('                                 , :zpscanby, :zmkillword );');
    UniQueryCoreCreate.SQL.Add('               end /* End of Insert new Pallet */');
    UniQueryCoreCreate.SQL.Add('           end');
    UniQueryCoreCreate.SQL.Add('        /* Using Layers per pallet and rolls per layer see if this pallet');
    UniQueryCoreCreate.SQL.Add('        should be closed and a new one opened */');
    UniQueryCoreCreate.SQL.Add('        RollsOnPallet = 0;');
    UniQueryCoreCreate.SQL.Add('        ZPITM       = Gen_id(papitm_gen,1);');
    UniQueryCoreCreate.SQL.Add('        /* Calc next Roll Seq Num GRON01 */');
    UniQueryCoreCreate.SQL.Add('        Select MAX(ZPITMX) AS XMIN');
    UniQueryCoreCreate.SQL.Add('        FROM PAPITM');
    UniQueryCoreCreate.SQL.Add('        WHERE ZPALLET = :zpallet ');
    UniQueryCoreCreate.SQL.Add('        into  ZPITMX ;');
    UniQueryCoreCreate.SQL.Add('        /* Inc Next item Seq Number */');
    UniQueryCoreCreate.SQL.Add('        zpitmx = coalesce(zpitmx,0) + 1 ; -- Box/Items seq on this pallet');
    UniQueryCoreCreate.SQL.Add('        --ZPALLET     = Zpallet');
    UniQueryCoreCreate.SQL.Add('        ZPCOREWGT     = ((zslwidth / 1000.00) * coalesce(zcorewgt,0) );  -- Calc Core weight from (Face Width (MM) * (Core Kg/M)');
    UniQueryCoreCreate.SQL.Add('        if (zusegross = ''T'') then');
    UniQueryCoreCreate.SQL.Add('          ZITMWGT     = Weight_in;  -- Calc Net or Gross weight depending on Cust');
    UniQueryCoreCreate.SQL.Add('        else');
    UniQueryCoreCreate.SQL.Add('          ZITMWGT     = (Weight_in - ZPCOREWGT );  -- Calc Net by subtract core Kg');
    UniQueryCoreCreate.SQL.Add('        ZPGROSS     = ZUSEGROSS;');
    UniQueryCoreCreate.SQL.Add('        ZPIUSERLEN  = ''F'';  -- No as Kampf Machine made the length');
    UniQueryCoreCreate.SQL.Add('        ZPIUSER     = ZCLOCK;');
    UniQueryCoreCreate.SQL.Add('        ZPIDATE     = AuditTime_in;');
    UniQueryCoreCreate.SQL.Add('        ZPILEN      = Length_in;');
    UniQueryCoreCreate.SQL.Add('        ZAUDIT      = audit_in;');
    UniQueryCoreCreate.SQL.Add('        if (coalesce(zrptlen,0) > 0 ) then');
    UniQueryCoreCreate.SQL.Add('          ZIMP        =  (Length_in / (coalesce(zrptlen,1)/1000.00)   );   -- Calc from total length / zrptlen');
    UniQueryCoreCreate.SQL.Add('        else');
    UniQueryCoreCreate.SQL.Add('          ZIMP = 0;');
    UniQueryCoreCreate.SQL.Add('        ZIMGCOUNT   = ZIMP * coalesce(zimages,0);  -- Calc from (total length / image rpt) * Teddybears Per image');
    UniQueryCoreCreate.SQL.Add('        --ZCORE       = zcore; -- C/08 From ZSLCORE');
    UniQueryCoreCreate.SQL.Add('        ZROLLSEQ    = -1;');
    UniQueryCoreCreate.SQL.Add('        ZPQTY       = 0; -- Conversion Bag Count');

    UniQueryCoreCreate.SQL.Add('        if (bDoUpdate = 1) then');
    UniQueryCoreCreate.SQL.Add('         Begin');
    UniQueryCoreCreate.SQL.Add('            insert into papitm (ZPITM,ZPITMX,ZPALLET,ZITMWGT,ZPCOREWGT,ZPGROSS,');
    UniQueryCoreCreate.SQL.Add('                                ZPIUSERLEN,ZPIUSER,ZPIDATE,ZPILEN,ZAUDIT,ZIMP,');
    UniQueryCoreCreate.SQL.Add('                                ZIMGCOUNT,ZCORE,ZROLLSEQ,ZPQTY)');
    UniQueryCoreCreate.SQL.Add('             values             (:ZPITM,:ZPITMX,:ZPALLET,:ZITMWGT,:ZPCOREWGT,:ZPGROSS,');
    UniQueryCoreCreate.SQL.Add('                                 :ZPIUSERLEN,:ZPIUSER,:ZPIDATE,:ZPILEN,:ZAUDIT,:ZIMP,');
    UniQueryCoreCreate.SQL.Add('                                 :ZIMGCOUNT,:ZCORE,:ZROLLSEQ,:ZPQTY);');
    UniQueryCoreCreate.SQL.Add('         End /* end of insert New Roll */');
    UniQueryCoreCreate.SQL.Add('        /* Fetch number of rolls on this pallet now */');
    UniQueryCoreCreate.SQL.Add('       Select Cast(Count(ix.zpitm) as Integer) as rpl');
    UniQueryCoreCreate.SQL.Add('       from papitm ix');
    UniQueryCoreCreate.SQL.Add('       where ix.zpallet = :zpallet');
    UniQueryCoreCreate.SQL.Add('       into RollsOnPallet;');
    UniQueryCoreCreate.SQL.Add('       /* Pallet is full?, then close it here */');
    UniQueryCoreCreate.SQL.Add('       if ( RollsOnPallet >= (zslrplay *  zsllayplt )) then');
    UniQueryCoreCreate.SQL.Add('        /* Close the pallet */');
    UniQueryCoreCreate.SQL.Add('        Begin');
    UniQueryCoreCreate.SQL.Add('         update papallet px');
    UniQueryCoreCreate.SQL.Add('         set px.zpopen = ''F''');
    UniQueryCoreCreate.SQL.Add('         where px.zpallet = :zpallet;');
    UniQueryCoreCreate.SQL.Add('         zpopen = ''F''; /* Tell User we closed pallet */');
    UniQueryCoreCreate.SQL.Add('        end');
    UniQueryCoreCreate.SQL.Add('     suspend;');
    UniQueryCoreCreate.SQL.Add(' end');
    Try
      UniQueryCoreCreate.open;
      zpallet  := UniQueryCoreCreate.FieldByname('zpallet').AsInteger;
      zpitem   := UniQueryCoreCreate.FieldByname('ZPITM').AsInteger;
      UniQueryCoreCreate.Transaction.Commit;

    Except
      On E :Exception do
       begin
         Debug_Logging('****  FAILED CREATING PALLET / ROLL **** SQL : ' +
                        UniQueryCoreCreate.SQL.text +
                        ' Error : ' +
                        E.message +
                        #$0d+#$0a , clWebSalmon);
       end;
    End;


End;



procedure TFormMain_Koch.PrintOutSideLabelDB4111;
var
   CoreRoll    : Integer;
   CorePallet  : Integer;

Begin
  // DB4111 Block  Outside Core label
  // fetch What to print from Koch
   CoreRoll    := Read_int_Value(K_DB4111_Outside_label_Roll_No);    // Outside label to print
  // Call Db to find Pallet so we can Call DB again to get job info
   CorePallet :=  Fetch_Pallet_For_zpitm(CoreRoll);
   // New function to find Pallet for Roll number supplied.
  if CorePallet > 0 then
    begin
     Print_Core_Label_DB4102(CorePallet,CoreRoll, KochExtRollPrinterName ); /// Blocking Risk Here ???
     WaitingFor_ExternalRollPrintDrop := True;
     Debug_Logging('>>>> External Roll Printed :'+ CorePallet.tostring +' , Roll :'+ CoreRoll.tostring,clLime);
    end
  else
    Debug_Logging('External roll label request failed, Roll # received = ' + CoreRoll.toString + ' Pallet Lookup Gave : '+CorePallet.tostring,clWebSalmon);

End;

procedure TFormMain_Koch.Print_A5_Pallet_Label_DB4125;
// K_DB4121_Pallet_lable_Print_label  print action to Printer
// this selects the print label from the ACCST table , the side it needs to
// print comes from the PLC and we select the customer specific label based on it.
var
   izPallet   : Integer;
   iPrintSide : Integer;
   iError     : Integer;
   iPrinter   : Integer; //Selected destination printer 1 = Normal , 2 = Spare
Begin
  // DB4111 Block  Outside Core label
  // fetch What to print from Koch
  iError     := 0;
  iPrinter   := 1; // Default to main printer

  izpallet    := Read_int_Value(K_DB4125_Pallet_label_Pallet_No);       // Extract ZPALLET from Koch Data
  iPrinter    := Read_int_Value(K_DB4125_Pallet_label_Label_Printer);   // Extract Destination printer from Koch [1..4]
  if iZPallet > 0 then
    begin
     iPrintSide  := Read_int_Value(K_DB4125_Pallet_label_side_of_pallet);  // Side to print label on
     if iPrintSide > 0 then
      begin

        // COLIN NOTE: We always send the pallet label to both printers, the Koch system then decides
        // which printer is the best one and then it deletes  the print data from the other printer.
        // Sat 30 Oct 2021, Testing with actual pallets starts next week.
        // Since 14th Jan now 2022 Koch send us a flag to say what is the destination printer

        if (iPrinter = 1) then
         Begin // Standard printer is in use...
            // Now Print the Roll Label ....   !!!!!  BLOCKING !!!!! .. Maybe Use a Thread for roll print
            if CheckBoxFullDebug.checked then
               Debug_Logging('Request to print A5 Label :'+ izPallet.tostring +' On side :'+ iPrintSide.tostring,clskyblue);
            //   *****   MAIN A5 PRINTER LABEL  ******
            Print_A5_Label_DB4125(iZPallet,iPrintSide, KochPalletA5MainPrinterName, iError );    /// Blocking Risk Here ???

            Case iError Of
             K_Koch_IllegalSide_supplied : Debug_Logging('MAIN A5 :Illegal Side or request to send to bad side '+iPrintSide.ToString + ' from Koch for Pallet '+ iZpallet.toString,clWebSalmon);
             K_Koch_NoPalletLabelForSide : Debug_Logging('MAIN A5 :No Pallet configured in ACCST for side '+iPrintSide.ToString + '. Pallet :' + iZpallet.toString,clWebSalmon);
            End;
            if iError > 0 then
             Exit ;
            if CheckBoxFullDebug.checked then
               Debug_Logging('>>>> Printed A5 Label to MAIN:'+ izPallet.tostring +' On side :'+ iPrintSide.tostring,cllime);
         end
      else
        begin
            //   *****   STANDBY A5 PRINTER LABEL  ******
            Print_A5_Label_DB4125(iZPallet,iPrintSide, KochPalletA5StandByPrinterName, iError ); /// Blocking Risk Here ???
            Case iError Of
             K_Koch_IllegalSide_supplied : Debug_Logging('STANDBY A5 :Illegal Side or request to send to bad side '+iPrintSide.ToString + ' from Koch for Pallet '+ iZpallet.toString,clWebSalmon);
             K_Koch_NoPalletLabelForSide : Debug_Logging('STANDBY A5 :No Pallet configured in ACCST for side '+iPrintSide.ToString + '. Pallet :' + iZpallet.toString,clWebSalmon);
            End;
            if iError > 0 then
             Exit ;

            if CheckBoxFullDebug.checked then
               Debug_Logging('>>>> Printed A5 Label to SPARE:'+ izPallet.tostring +' On side :'+ iPrintSide.tostring,clLime);

            WaitingFor_A5PalletPrintToDrop := True;
        end;
      end
     Else
       Debug_Logging('FAILURE: Invalid Request to print A5 Label :'+ izPallet.tostring +' On side :'+ iPrintSide.tostring,clWebSalmon);
    end
   Else
     Debug_Logging('FAILURE: Invalid Request to print A5 Label : 0',clWebSalmon);
end;


procedure TFormMain_Koch.Print_Pallet_Block_ID_LabelDB4124;
var
//   izroll    : Integer;
   iZPallet  : Integer;

Begin
  // K_DB4122_Block_label_Pallet_No Block label
  // Fetch What to print from Koch
   iZPallet    := Read_int_Value(K_DB4124_Block_label_Pallet_No);    // Outside label to print

//  // New function to find Pallet for Roll number supplied.
//  iZpallet := Fetch_Pallet_For_zpitm(iZroll);

  if iZPallet > 0 then
    begin
        if CheckBoxFullDebug.checked then
             Debug_Logging('Request to print Block ID label for Pallet #  ' + iZpallet.tostring,cllime);
        // Now Print the ID Block Label ....   !!!!!  BLOCKING !!!!! .. Maybe Thread for roll print
        Print_Pallet_ID_Label_DB4124(iZPallet,KochPalletIDPrinterName ); /// Blocking Risk Here ???

        if CheckBoxFullDebug.checked then
          Debug_Logging('>>>> Printed ID Block Pallet # '+ iZPallet.tostring,clLime );
        WaitingFor_PalletIDPrintToDrop := true;
    end
  Else
   Debug_Logging('FAILURE : Printing ID Block Pallet # '+ iZPallet.tostring,clWebSalmon );
End;





function TFormMain_Koch.Fetch_Pallet_For_zpitm(const zpitm: Integer): integer;
var
 Query        : TUniQuery ;
 Transaction  : TUniTransaction;
begin          // Find pallet thast roll is a member of
 Fetch_Pallet_For_zpitm := 0;
 try
   Transaction := TUniTransaction.Create(nil);
   Transaction.DefaultConnection := DMSIVADATA.UniConnectionMain;
   Query := TUniQuery.create(nil);
   Query.Transaction := transaction;
   Query.Connection  := DMSIVADATA.UniConnectionMain;
   Query.Sql.Clear;
   Query.Sql.Add('Select zPallet from papitm where zpitm = ' + zpitm.ToString );
   Query.open;
   if Query.FieldByName('zPallet').isnull then
      Fetch_Pallet_For_zpitm := 0
   else
      Fetch_Pallet_For_zpitm := Query.FieldByName('zPallet').AsInteger;
 finally
   Query.close;
   Transaction.rollback;
   Transaction.free;
   Query.free;
 end;

end;

function TFormMain_Koch.Fetch_Running_Koch_Jobs(const izword :integer;
                                                var  zclock  :Integer;
                                                var  zm      :Integer): Boolean;
var
 iworksord :integer;
begin
 // First Clear all the currect records to zero;
 zclock := 0;
 zm     := 0;
 Result := False; // No job found !!!

 iWorksOrd  := Read_int_Value(K_DB4103_Order_Data_WorksorderNoL1);
 if iWorksOrd = izword then
  Begin
   zclock  :=   Read_int_Value(K_DB4103_Order_Data_EmployeeNoL1);
   zm      :=   Read_int_Value(K_DB4103_Order_Data_MachineNoL1);
   result  :=   True; // Worksorder running
   Exit;
  End;

 iWorksOrd := Read_int_Value(K_DB4103_Order_Data_WorksorderNoL2);
 if iWorksOrd = izword then
  Begin
   zclock  :=   Read_int_Value(K_DB4103_Order_Data_EmployeeNoL2);
   zm      :=   Read_int_Value(K_DB4103_Order_Data_MachineNoL2);
   result  :=   True; // Worksorder running
   Exit;
  End;

 iWorksOrd := Read_int_Value(K_DB4103_Order_Data_WorksorderNoL3);
 if iWorksOrd = izword then
  Begin
   zclock  :=   Read_int_Value(K_DB4103_Order_Data_EmployeeNoL3);
   zm      :=   Read_int_Value(K_DB4103_Order_Data_MachineNoL3);
   result  :=   True; // Worksorder running
   Exit;
  End;

 iWorksOrd := Read_int_Value(K_DB4103_Order_Data_WorksorderNoL4);
 if iWorksOrd = izword then
  Begin
   zclock  :=   Read_int_Value(K_DB4103_Order_Data_EmployeeNoL4);
   zm      :=   Read_int_Value(K_DB4103_Order_Data_MachineNoL4);
   result  :=   True; // Worksorder running
   Exit;
  End;

 iWorksOrd := Read_int_Value(K_DB4103_Order_Data_WorksorderNoL5);
 if iWorksOrd = izword then
  Begin
   zclock  :=   Read_int_Value(K_DB4103_Order_Data_EmployeeNoL5);
   zm      :=   Read_int_Value(K_DB4103_Order_Data_MachineNoL5);
   result  :=   True; // Worksorder running
   Exit;
  End;

 iWorksOrd := Read_int_Value(K_DB4103_Order_Data_WorksorderNoL6);
 if iWorksOrd = izword then
  Begin
   zclock  :=   Read_int_Value(K_DB4103_Order_Data_EmployeeNoL6);
   zm      :=   Read_int_Value(K_DB4103_Order_Data_MachineNoL6);
   result  :=   True; // Worksorder running
   Exit;
  End;

end;

Function TFormMain_Koch.Fetch_Word_For_zpallet(const zpallet   :Integer;
                                               var zpstate     :integer;
                                               var final_State :Integer;
                                               var zplt        :integer ):integer;
var
 Query        : TUniQuery ;
 Transaction  : TUniTransaction;
begin          // Find Worksorder that a pallet is a mamber of
 result := 0;
 try
   Transaction := TUniTransaction.Create(nil);
   Transaction.DefaultConnection := DMSIVADATA.UniConnectionMain;
   Query := TUniQuery.create(nil);
   Query.Transaction := transaction;
   Query.Connection  := DMSIVADATA.UniConnectionMain;
   Query.Sql.Clear;
   Query.Sql.Add('select p.zword, p.zpstate,p.zplt, s.zpstate as Final_State ');
   Query.Sql.Add('from Papallet p');
   Query.Sql.Add('join worksord w on w.zword = p.zword');
   Query.Sql.Add('join acspec   s on s.zspec = w.zspec');
   Query.Sql.Add('where p.zpallet = ' + zpallet.ToString );
   Query.open;
   if Query.FieldByName('zword').isnull then
      Result := 0
   else
     begin
       zpstate     := Query.FieldByName('zpstate').AsInteger;
       final_State := Query.FieldByName('final_State').AsInteger;
       zplt        := Query.FieldByName('zplt').AsInteger;
       Result      := Query.FieldByName('zword').AsInteger;
     end;
 finally
   Query.close;
   Transaction.rollback;
   Transaction.free;
   Query.free;
 end;
end;





procedure TFormMain_Koch.FillReadnamedropdown;
var
 ddi :TDropDownItem;
  i: Integer;
  Procedure additem(DropDownTarget :TAdvGridDropDown;  const sBlock : String ; const sAddress:String);
   begin
     ddi := DropDownTarget.items.Add;
     ddi.Text.add(sBlock);
     ddi.Text.add(sAddress);
   end;
begin
    AdvGridDropDownreadNames.BeginUpdate;
    AdvGridDropDownReadNames.items.Clear;
    additem(AdvGridDropDownReadNames,'K_DB4100_Main_request_Data',        K_DB4100_Main_request_Data);
    additem(AdvGridDropDownReadNames,'K_DB4100_Main_Error_flag',          K_DB4100_Main_Error_flag);
    additem(AdvGridDropDownReadNames,'K_DB4100_Main_Error_Code',          K_DB4100_Main_Error_Code);
    additem(AdvGridDropDownReadNames,'K_DB4100_Main_status',              K_DB4100_Main_status);
    additem(AdvGridDropDownReadNames,'K_DB4100_Main_Employee_No',         K_DB4100_Main_Employee_No);
    additem(AdvGridDropDownReadNames,'K_DB4100_Main_Worksorder_No',       K_DB4100_Main_Worksorder_No);
    additem(AdvGridDropDownReadNames,'K_DB4100_Main_Machine_No'          ,K_DB4100_Main_Machine_No);

    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_EmployeeNoL1',  K_DB4103_Order_Data_EmployeeNoL1);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_WorksorderNoL1',K_DB4103_Order_Data_WorksorderNoL1);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_MachineNoL1',   K_DB4103_Order_Data_MachineNoL1);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_EmployeeNoL2',  K_DB4103_Order_Data_EmployeeNoL2);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_WorksorderNoL2',K_DB4103_Order_Data_WorksorderNoL2);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_MachineNoL2',   K_DB4103_Order_Data_MachineNoL2);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_EmployeeNoL3',  K_DB4103_Order_Data_EmployeeNoL3);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_WorksorderNoL3',K_DB4103_Order_Data_WorksorderNoL3);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_MachineNoL3',   K_DB4103_Order_Data_MachineNoL3);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_EmployeeNoL4',  K_DB4103_Order_Data_EmployeeNoL4);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_WorksorderNoL4',K_DB4103_Order_Data_WorksorderNoL4);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_MachineNoL4',   K_DB4103_Order_Data_MachineNoL4);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_EmployeeNoL5',  K_DB4103_Order_Data_EmployeeNoL5);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_WorksorderNoL5',K_DB4103_Order_Data_WorksorderNoL5);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_MachineNoL5',   K_DB4103_Order_Data_MachineNoL5);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_EmployeeNoL6',  K_DB4103_Order_Data_EmployeeNoL6);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_WorksorderNoL6',K_DB4103_Order_Data_WorksorderNoL6);
    additem(AdvGridDropDownReadNames,'K_DB4103_Order_Data_MachineNoL6',   K_DB4103_Order_Data_MachineNoL6);


    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_Roll_No',    K_DB4101_Core_Labeling_Roll_No);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_Pallet_No',  K_DB4101_Core_Labeling_Pallet_No);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_audit_no',   K_DB4101_Core_Labeling_audit_no);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_Audit_timestamp',K_DB4101_Core_Labeling_Audit_timestamp);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_Worksorder_No',K_DB4101_Core_Labeling_Worksorder_No);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_Weight',     K_DB4101_Core_Labeling_Weight);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_length',     K_DB4101_Core_Labeling_length);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_CreateRoll', K_DB4101_Core_Labeling_CreateRoll);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_CoreRoll',   K_DB4101_Core_Labeling_CoreRoll);
    additem(AdvGridDropDownReadNames,'K_DB4101_Core_Labeling_Print_label',K_DB4101_Core_Labeling_Print_label);

    additem(AdvGridDropDownReadNames,'K_DB4111_Outside_label_Roll_No',    K_DB4111_Outside_label_Roll_No);
    additem(AdvGridDropDownReadNames,'K_DB4111_Outside_label_Print_label',K_DB4111_Outside_label_Print_label);

    additem(AdvGridDropDownReadNames,'K_DB4123_MasterRoll_Pallet_No',     K_DB4123_MasterRoll_Pallet_No);
    additem(AdvGridDropDownreadNames,'K_DB4123_MasterRoll_Pallet_Lookup', K_DB4123_MasterRoll_Pallet_Lookup);

    additem(AdvGridDropDownReadNames,'K_DB4124_Block_label_Pallet_No',      K_DB4124_Block_label_Pallet_No);
    additem(AdvGridDropDownReadNames,'K_DB4124_Block_label_Print_label',  K_DB4124_Block_label_Print_label);

    additem(AdvGridDropDownReadNames,'K_DB4125_Pallet_lable_Pallet_No',   K_DB4125_Pallet_label_Pallet_No);
    additem(AdvGridDropDownReadNames,'K_DB4125_Pallet_lable_side_of_pallet',K_DB4125_Pallet_label_side_of_pallet);
    additem(AdvGridDropDownReadNames,'K_DB4125_Pallet_lable_Print_label', K_DB4125_Pallet_label_Print_label);
    additem(AdvGridDropDownReadNames,'K_DB4125_Pallet_label_Label_Printer', K_DB4125_Pallet_label_Label_Printer);

    AdvGridDropDownreadNames.ItemIndex := 0;
    AdvGridDropDownreadNames.EndUpdate;


    AdvGridDropDownWriteNames.items.Clear;
    AdvgridDropDownWritenames.BeginUpdate;
    additem(AdvGridDropDownWriteNames,'K_DB4100_Main_SIVA_MIS_status'       ,K_DB4100_Main_SIVA_MIS_status);
    additem(AdvGridDropDownWriteNames,'K_DB4100_Main_data_send'             ,K_DB4100_Main_data_send);

    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Rolls_per_Layer'   ,K_DB4102_Job_data_Rolls_per_Layer);
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Layers_Per_Pallet' ,K_DB4102_Job_data_Layers_Per_Pallet);
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Type_Of_Pallet'    ,K_DB4102_Job_data_Type_Of_Pallet);
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Pattern'           ,K_DB4102_Job_data_Pattern);
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Cutting_width'     ,K_DB4102_Job_data_Cutting_width);
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Diameter'          ,K_DB4102_Job_data_Diameter);
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_packaging'         ,K_DB4102_Job_data_packaging);
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Wrapping_program'  ,K_DB4102_Job_data_Wrapping_program);   // NEW NOV 2021
    additem(AdvGridDropDownWriteNames,'K_DB4102_Job_data_Strapping_program' ,K_DB4102_Job_data_Strapping_program);  // NEW NOV 2021
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_Side1'             ,K_DB4102_Job_Data_Label_Side1);
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_orientation_1'     ,K_DB4102_Job_Data_Label_orientation_1);
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_Side2'             ,K_DB4102_Job_Data_Label_Side2);
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_orientation_2'     ,K_DB4102_Job_Data_Label_orientation_2);
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_Side3'             ,K_DB4102_Job_Data_Label_Side3);
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_orientation_3'     ,K_DB4102_Job_Data_Label_orientation_3);
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_Side4'             ,K_DB4102_Job_Data_Label_Side4);
    AddItem(AdvgridDropDownWritenames,'K_DB4102_Job_Data_orientation_4'     ,K_DB4102_Job_Data_Label_orientation_4);


    AddItem(AdvgridDropDownWritenames,'K_DB4123_MasterRoll_Number_Good'     ,K_DB4123_MasterRoll_Number_Good);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_MasterRoll_Typ_of_pallet'   ,K_DB4123_MasterRoll_Typ_of_pallet);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_Side1'     ,K_DB4123_Masterroll_Label_Side1);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_orientation_1',K_DB4123_Masterroll_Label_Orientation_1);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_Side2'     ,K_DB4123_Masterroll_Label_Side2);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_orientation_2',K_DB4123_Masterroll_Label_Orientation_2);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_Side3'     ,K_DB4123_Masterroll_Label_Side3);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_orientation_3',K_DB4123_Masterroll_Label_Orientation_3);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_Side4'     ,K_DB4123_Masterroll_Label_Side4);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_Masterroll_Label_orientation_4',K_DB4123_Masterroll_Label_Orientation_4);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_MasterRoll_Wrapping_program',K_DB4123_MasterRoll_Wrapping_program);   // NEW NOV 2021
    AddItem(AdvgridDropDownWritenames,'K_DB4123_MasterRoll_Done'            ,K_DB4123_MasterRoll_Done);
    AddItem(AdvgridDropDownWritenames,'K_DB4123_MasterRoll_Error'           ,K_DB4123_MasterRoll_Error);

    AdvgridDropDownWritenames.ItemIndex := 0;
    AdvgridDropDownWritenames.EndUpdate;

end;

procedure TFormMain_Koch.Handle_MasterRoll_Event_DB4123();
//Begin
 (* Load the Master roll data from the PLC and send the Pallet information
  DB4124 Block MAster roll request from Koch *)
Var
 iZPallet         : Integer;
 OrderStructure   : TOrderInfo ;
 FetchResult      : Integer;
 izword ,izm      : Integer;
 EmployeeNo       : Integer;
 zpstate          : Integer;
 final_state      : Integer;
 PalletZPSTATE    : String;
 Wrapping_program : Integer;
 Pallet_Type      : Integer;

begin
   PalletZPSTATE := '?';
   Pallet_Type   := 0;


   iZPallet := Read_Int_Value(K_DB4123_MasterRoll_Pallet_No);

   // need to find the worksorder for the palletnumber in the PLC
   izword :=  Fetch_Word_For_zpallet({const}izpallet, {var}zpstate, {var}final_state , {var zplt}Pallet_Type);

   if izword = 0 then
    Begin
      Debug_Logging('Invalid pallet/works order for Master Roll in PLC izpallet = '+izPallet.tostring,clWebSalmon);
      WriteNodeValue( K_DB4123_MasterRoll_Number_Good   , 'False'); //Failed, Bad Pallet number !!!!
      WriteNodeValue( K_DB4123_MasterRoll_Done          , 'True');  //Failed, Bad Pallet number !!!!
      WaitingFor_MasterRollPalletSentToDrop             := True; // Set clear on Pallet sent drops
      Exit;
    End;

 // Fetch Works order info from DB and return to Koch
   EmployeeNo  := -1; // Dont test for employee if masterroll
   iZM         := -1; // Dont test for Machine

   FetchResult :=  FetchWorksOrderData(iZword, EmployeeNo{-1 dont check emp}, OrderStructure) ;

   if (FetchResult > 0) then   // >0 = FAILED !!
    Begin
      if CheckBoxFullDebug.checked then
         Debug_Logging('Failed sending master roll data for zpallet = '+izpallet.tostring,clWebSalmon);
      WriteNodeValue( K_DB4123_MasterRoll_Number_Good         , 'False');  //Bad Pallet or works order found
      WriteNodeValue( K_DB4123_MasterRoll_Pallet_Lookup       , 'True');   //Transmit block updated Flag to koch.. Even though it crashed out
      WriteNodeValue( K_DB4123_MasterRoll_typ_of_pallet       , '0' );
      WriteNodeValue( K_DB4123_Masterroll_Label_Side1         , 'False' );
      WriteNodeValue( K_DB4123_Masterroll_Label_orientation_1 , 'False' );
      WriteNodeValue( K_DB4123_Masterroll_Label_Side2         , 'False' );
      WriteNodeValue( K_DB4123_Masterroll_Label_orientation_2 , 'False' );
      WriteNodeValue( K_DB4123_Masterroll_Label_Side3         , 'False' );
      WriteNodeValue( K_DB4123_Masterroll_Label_orientation_3 , 'False' );
      WriteNodeValue( K_DB4123_Masterroll_Label_Side4         , 'False' );
      WriteNodeValue( K_DB4123_Masterroll_Label_orientation_4 , 'False' );
      WriteNodeValue( K_DB4123_MasterRoll_Wrapping_program    , '0'  );
      WriteNodeValue( K_DB4123_MasterRoll_Done                , 'True' );  // Raise Done flag
      WriteNodeValue( K_DB4123_MasterRoll_Error               , 'False' );
      WaitingFor_MasterRollPalletSentToDrop   := True; // Set clear on Pallet sent drops
    End
   else
    Begin
      if (zpstate <> final_state) then // Only output Siva label on side 1 if Work In Progress (WIP)
       Begin
         OrderStructure.Label_Side_1       := True;  // Only Use Siva Pallet label on side 1 for WIP
         OrderStructure.LabelOrientation_1 := False;
         OrderStructure.Label_Side_2       := False; // No other labels for WIP
         OrderStructure.LabelOrientation_2 := False;
         OrderStructure.Label_Side_3       := False;
         OrderStructure.LabelOrientation_3 := False;
         OrderStructure.Label_Side_4       := False;
         OrderStructure.LabelOrientation_4 := False;
         WriteNodeValue( K_DB4123_Masterroll_Label_Side1         , OrderStructure.Label_Side_1 );
         WriteNodeValue( K_DB4123_Masterroll_Label_orientation_1 , OrderStructure.LabelOrientation_1 );
         WriteNodeValue( K_DB4123_Masterroll_Label_Side2         , OrderStructure.Label_Side_2 );
         WriteNodeValue( K_DB4123_Masterroll_Label_orientation_2 , OrderStructure.LabelOrientation_2 );
         WriteNodeValue( K_DB4123_Masterroll_Label_Side3         , OrderStructure.Label_Side_3 );
         WriteNodeValue( K_DB4123_Masterroll_Label_orientation_3 , OrderStructure.LabelOrientation_3 );
         WriteNodeValue( K_DB4123_Masterroll_Label_Side4         , OrderStructure.Label_Side_4 );
         WriteNodeValue( K_DB4123_Masterroll_Label_orientation_4 , OrderStructure.LabelOrientation_4 );
       End
      Else
       Begin // Its a finished Pallet then use Final pallet Label requirements..go tell Koch,so they can ask later at Print A4 Station
          WriteNodeValue( K_DB4123_Masterroll_Label_Side1         , OrderStructure.Label_Side_1 );
          WriteNodeValue( K_DB4123_Masterroll_Label_orientation_1 , OrderStructure.LabelOrientation_1 );
          WriteNodeValue( K_DB4123_Masterroll_Label_Side2         , OrderStructure.Label_Side_2 );
          WriteNodeValue( K_DB4123_Masterroll_Label_orientation_2 , OrderStructure.LabelOrientation_2 );
          WriteNodeValue( K_DB4123_Masterroll_Label_Side3         , OrderStructure.Label_Side_3 );
          WriteNodeValue( K_DB4123_Masterroll_Label_orientation_3 , OrderStructure.LabelOrientation_3 );
          WriteNodeValue( K_DB4123_Masterroll_Label_Side4         , OrderStructure.Label_Side_4 );
          WriteNodeValue( K_DB4123_Masterroll_Label_orientation_4 , OrderStructure.LabelOrientation_4 );
       End;


      WriteNodeValue( K_DB4123_MasterRoll_Number_Good         , 'True'); //Great Pallet or works order found ok

      Wrapping_program := 1;
      Pallet_Type      := 3; // 3 = Bad value
            // Ok now we need to know what the pallet is, to select the correct wrapping program for Ext,prn,slt,etc...
            // Depending on the pallet zpstate we need to select the correct pallet to goto Koch
      case zpstate of
         KP_FILM                  ,
         KP_FILM_QUAR             :Begin
                                     PalletZPSTATE := ' Extrusion ' ;
                                     Wrapping_program := OrderStructure.Ext_Wrap_program;
                                     Pallet_Type      := OrderStructure.Ext_zplt;
                                   End;

         KP_BAG                   ,
         KP_SHEET                 ,
         KP_PRINT_BAG             ,
         KP_PRINT_SHEET           ,
         KP_BAG_QUAR              ,
         KP_SHEET_QUAR            ,
         KP_PRINT_BAG_QUAR        ,
         KP_PRINT_SHEET_QUAR      ,
         KP_WICKET_PRODUCT        : Begin
                                     PalletZPSTATE := ' Conversion ' ;
                                     Wrapping_program := OrderStructure.Cnv_Wrap_program;
                                     Pallet_Type      := OrderStructure.cnv_zplt;
                                     End;

         KP_PRINT                 ,
         KP_PRINT_QUAR,
         KP_JUMBO                 : Begin
                                     PalletZPSTATE := ' Printing ' ;
                                     Wrapping_program := OrderStructure.Prn_Wrap_program;
                                     Pallet_Type      := OrderStructure.Prn_zplt;
                                    End;

         KP_LAMINATED             ,
         KP_LAMINATED_QUAR        : Begin
                                     PalletZPSTATE := ' Lamination ' ;
                                     Wrapping_program := OrderStructure.Lam_Wrap_program;
                                     Pallet_Type      := OrderStructure.Lam_zplt;
                                    End;

         KP_SLITTING              ,
         KP_SLITTING_QUAR         : Begin
                                     PalletZPSTATE := ' Slitting ' ;
                                     Wrapping_program := OrderStructure.Wrapping_Program;
                                     Pallet_Type      := OrderStructure.Slt_zplt;
                                     End;

         KP_FFS                   ,
         KP_FFS_PRINTED           ,
         KP_FFS_SEALDBAGS         ,
         KP_FFS_SEALEDPRIN_BAG    ,
         KP_FFS_SEALEDPRIN_SHT    ,
         KP_FFS_SEALEDPRIN_PSHT   ,
         KP_FFS_QUAR              ,
         KP_FFS_PRINTED_QUAR      : Begin
                                     PalletZPSTATE := ' FFS ' ;
                                     Wrapping_program := OrderStructure.FFS_Wrap_program;
                                     Pallet_Type      := OrderStructure.FFS_zplt;
                                     End ;

         KP_NGR                    : Begin
                                       PalletZPSTATE := ' NGR ' ;
                                       Wrapping_program := OrderStructure.NGR_Wrap_Program;
                                       Pallet_Type      := Koch_Pallet_Translate(Pallet_Type); // Translate Org Pallet type
                                     End
      Else
         begin
          Debug_Logging('Unknown Master roll Pallet type '+iZPallet.tostring ,clskyBlue);
          Wrapping_program := 0; // Dafault to None;    , This will fail at Koch station
          Pallet_Type      := 3; // Illegal pallet type , This will fail at Koch station
         end;
      end;

      WriteNodeValue( K_DB4123_MasterRoll_Wrapping_program , Wrapping_program.ToString); // Dafault to Ext slitting
      WriteNodeValue( K_DB4123_MasterRoll_typ_of_pallet    , Pallet_type.ToString);


      WriteNodeValue( K_DB4123_MasterRoll_Done                , 'True' );  // Faise Done flag
      WriteNodeValue( K_DB4123_MasterRoll_Error               , 'False' );   //Data Sent flag to Koch
      WaitingFor_MasterRollPalletSentToDrop   := True; // Set clear on Pallet sent drops

      if CheckBoxFullDebug.checked then
         Begin
            Debug_Logging('WaitingFor_MasterRollPalletSentToDrop Has set',clskyBlue);
            Debug_Logging('Pallet # '+iZPallet.tostring +'. Pallet State = ' + PalletZPSTATE,clWindow);

            Debug_Logging('K_DB4123_MasterRoll_Number_Good           '+ 'True',clWindow);
            // A little story, , There are not only two types of pallet acording to some !!!, as we have 30 odd zplt types
            // I figured this fairly early, so I caretd a new field in the ACOPALT table to say this is considered
            // to be a CHEP or a EURO pallet, now on the 4th MAy 2022 Adrian needs another type of Pallet , A BLUE CHEP pallet
            // So this can now be
            Debug_Logging('K_DB4123_MasterRoll_typ_of_pallet(Ext)    '+ Pallet_Type.ToString,clWindow); // << 0=undifened 2=CHEP,1=EURO, 3=Blue CHEP ...THis can be an issue !!!
            Debug_Logging('K_DB4123_Masterroll_Label_Side1           '+ BoolToStr(OrderStructure.Label_Side_1,true),clWindow);
            Debug_Logging('K_DB4123_Masterroll_Label_orientation_1   '+ BoolToStr(OrderStructure.LabelOrientation_1,true),clWindow);
            Debug_Logging('K_DB4123_Masterroll_Label_Side2           '+ BoolToStr(OrderStructure.Label_Side_2,true),clWindow);
            Debug_Logging('K_DB4123_Masterroll_Label_orientation_2   '+ BoolToStr(OrderStructure.LabelOrientation_2,true),clWindow);
            Debug_Logging('K_DB4123_Masterroll_Label_Side3           '+ BoolToStr(OrderStructure.Label_Side_3,true),clWindow);
            Debug_Logging('K_DB4123_Masterroll_Label_orientation_3   '+ BoolToStr(OrderStructure.LabelOrientation_3,true),clWindow);
            Debug_Logging('K_DB4123_Masterroll_Label_Side4           '+ BoolToStr(OrderStructure.Label_Side_4,true),clWindow);
            Debug_Logging('K_DB4123_Masterroll_Label_orientation_4   '+ BoolToStr(OrderStructure.LabelOrientation_4,true),clWindow);
            Debug_Logging('K_DB4102_Job_data_Wrapping_program        '+ Wrapping_program.ToString,clWindow);   // << NEW NOV 2021
            Debug_Logging('K_DB4123_MasterRoll_Done                  '+ 'True',clWindow) ;
            Debug_Logging('K_DB4123_MasterRoll_Error                 '+ 'False',clWindow);
         End;
    End;

End;

//=============================================================================
//=============================================================================
//=============================================================================

procedure TFormMain_Koch.Label_Core_LabelDblClick(Sender: TObject);
begin
    // Send Test label to Pallet Id Printer 4"x3"
   SendTestpageTo_SmallPrinter(KochItemPrinterName);
end;

procedure TFormMain_Koch.Label_Outer_RollDblClick(Sender: TObject);
begin
   // Send Test label to External Roll Printer  4"x3"
  SendTestpageTo_SmallPrinter(KochExtRollPrinterName);
end;

procedure TFormMain_Koch.Label_Pallet_IDDblClick(Sender: TObject);
begin
   // Send Test label to Pallet Id Printer 4"x3"
   SendTestpageTo_SmallPrinter(KochPalletIDPrinterName);
end;

procedure TFormMain_Koch.Label_Main_PalletDblClick(Sender: TObject);
begin
  // Send test printout to Main Printer A5
  SendTestpageTo_A5(KochPalletA5MainPrinterName);
end;

procedure TFormMain_Koch.Label_Standby_PrinterDblClick(Sender: TObject);
begin
 // Send test printout to Backup Printer A5
  SendTestpageTo_A5(KochPalletA5StandByPrinterName);
end;

//=============================================================================
//=============================================================================
//=============================================================================

procedure TFormMain_Koch.SendTestpageTo_A5(const sTargetPrinter :String);
var
 Wprintform      : TFormRBWeighPrint;
Begin
 Try
    Wprintform                    := TFormRBWeighPrint.Create(self);
    Wprintform.currenttransaction := UniTransactionKochMain;
    Wprintform.ForceTransactions(UniTransactionKochMain);  // This sets the actual UniQuery Comps , Not done in line above
    // PRINT  TEST PALLET LABELS  SECTION
    if (Assigned(Wprintform) )  Then
       Wprintform.PrintTestA5Label(sTargetPrinter);
 Finally
   Wprintform.free;
 End;
end;

procedure TFormMain_Koch.SendTestpageTo_SmallPrinter(const sTargetPrinter :String);
var
 Wprintform      : TFormRBWeighPrint;
Begin
 Try
    Wprintform                    := TFormRBWeighPrint.Create(self);
    Wprintform.currenttransaction := UniTransactionKochMain;
    Wprintform.ForceTransactions(UniTransactionKochMain);  // This sets the actual UniQuery Comps , Not done in line above
    // PRINT  TEST CORE LABELS  SECTION
    if (Assigned(Wprintform) )  Then
       Wprintform.PrintTestCoreLabel(sTargetPrinter);
 Finally
   Wprintform.free;
 End;
end;


end.

